
#include <bits/stdc++.h>
using namespace std;

typedef long double ld;
typedef long long ll;
#define fr first
#define sc second
#define mpr mkae_pair

const int N=200006;
const ll MOD=998244353;
int a[N];
map<int,ll> mp;
vector<int> v[N];

struct node{
	ll sum,lazy,suml,sz;
} sg[4*N];


node merge(node b,node a,ll lz=0){
	node c;
	c.sz=a.sz+b.sz;
	c.lazy=lz;
	c.sum=a.sum+b.sum+(lz*c.sz);
	c.suml=a.suml+b.suml+(a.sz*b.sum)%MOD+(lz*(c.sz*(c.sz+1ll))%MOD)%MOD;
	c.sum%=MOD;
	c.lazy%=MOD;
	c.suml%=MOD;
	c.lazy=(c.lazy+MOD)%MOD;
	c.suml=(c.suml+MOD)%MOD;
	c.sum=(c.sum+MOD)%MOD;
	return c;
}


void update(int v,int tl,int tr,int l,int r,ll del){
	sg[v].sz=(tl-tr)+1;
	if (l>r) return;
	if (tl==l && tr==r){
		sg[v].lazy+=del;
		sg[v].suml+=(del*(sg[v].sz*(sg[v].sz+1ll)%MOD)%MOD);
		sg[v].sum+=(del*sg[v].sz)%MOD;
		sg[v].lazy%=MOD;
		sg[v].suml%=MOD;
		sg[v].sum%=MOD;
		sg[v].lazy=(sg[v].lazy+MOD)%MOD;
		sg[v].suml=(sg[v].suml+MOD)%MOD;
		sg[v].sum=(sg[v].sum+MOD)%MOD;
		return;
	}
	int tm=(tl+tr)/2;
	update(v+v,tl,tm,l,min(tm,r),del);
	update(v+v+1,tm+1,tr,max(l,tm+1),r,del);
	sg[v]=merge(sg[v+v],sg[v+v+1],sg[v].lazy);
}

node query(int v,int tl,int tr,int l,int r){
	sg[v].sz=(tl-tr)+1;
	if (l>r) return {0,0,0,0};
	if (tl==l && tr==r){
		return sg[v];
	}
	int tm=(tl+tr)/2;
	return merge(query(v+v,tl,tm,l,min(tm,r)),query(v+v+1,tm+1,tr,max(l,tm+1),r),sg[v].lazy);
}

int main(){
	ios_base::sync_with_stdio(false);
	int n;
	cin>>n;
	for (int i=1;i<=n;i++){
		cin>>a[i];
	}
	int m;
	cin>>m;
	int tv=0;
	for (int iii=0;iii<m;iii++){
		int l,r,tp;
		cin>>l>>r>>tp;
		tp=(tp+tv)%2+1;
		//cout<<tp<<endl;
		if (tp==1){
			l=(tv+l)%n+1;
			r=(tv+r)%100000000+1;
			a[l]=r;
		}
		else{
			l=(tv+l)%n+1;
			r=(tv+r)%n+1;
			//cout<<l<<" "<<r<<endl;
			ll megans=0;
			for (int i=l;i<=r;i++){
				ll mx=0,mxi=0;
				for (int j=i;j<=r;j++){
					mp[a[j]]++;
					if (mp[a[j]]>mx){
						mx=mp[a[j]];
						mxi=a[j];
					}
					if (2*mx>j-i+1)
						megans+=mxi;
					megans%=MOD;
					//cout<<i<<" "<<j<<" "<<mx<<" "<<mxi<<" "<<megans<<endl;
				}
				for (int j=i;j<=r;j++){
					mp[a[j]]--;
				}
			}
			tv=megans;
			cout<<megans<<endl;
		}
	}
	return 0;
}
//Cybm4dBm
/*
*/
