#include <iostream>
#include <algorithm>
#include <vector>
#include <queue>
#include <cmath>
#include <set>
#include <map>
using namespace std;
typedef long double LD;
const long double EPS=0.0001;
const int MAXN=1005;

long double x[MAXN], y[MAXN];
long double dist[MAXN][MAXN];
vector<long double> P;

// int per(int n, LD Px, LD Py);
inline LD D(LD x, LD y, LD X, LD Y);
int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	int Q, n, l, r, l_ind, r_ind;
	long double Px, Py, R;
	long double * it;
	cin>>n>>Q;
	for (int i=0; i<n; i++)
	{
		cin>>x[i]>>y[i];
		//dist[i].resize(n);
	}
	//init dist[0...n-1]...
	for (int i=0; i<n; i++)
	{
		for (int j=i; j<n; j++)
			dist[i][j]=dist[j][i]=D(x[i], y[i], x[j], y[j]);
	}
	for (int i=0; i<n; i++)
	{
		dist[i][i]=10000000.;
		sort(dist[i], dist[i]+n-1);
	}
	//~0.1
	while (Q--)
	{
		int ans=0;
		cin>>Px>>Py;
		//init P...
		P.clear();
		for (int i=0; i<n; i++)
			P.push_back(D(Px, Py, x[i], y[i]));
		sort(P.begin(), P.end());
		//1in tesak: P-n gagatn e
		//saxoh patuhan, p[l...r] bolor zuygeri tarberutyan moduly < EPS
		l=0, r=0;
		while (l<n)
		{
			while (r+1<P.size() && abs(P[r+1]-P[l])<EPS)
				r++; //binsearch?
			ans+=r-l; // (l, l+1), (l, l+2), (l, l+3), ..., (l, r) zuygry
			l++;
			if (r<l) // Es petqa???
				r=l;
		}
		//cerr<<"P-n gagtn e, ans = "<<ans<<'\n';;
		//2rd tesak: mi voreve (x[i]; y[i])-n e gagaty
		for (int i=0; i<n; i++)
		{ // (x[i]; y[i])-n e gagaty
			// hashvenq l, r aynpes vor (dist[i][l...r]-R) < EPS,
			// vortex R = D(P, i)
			R=D(Px, Py, x[i], y[i]);
			it=upper_bound(dist[i], dist[i]+n-1, R-EPS);
            if (it==dist[i]+n)
				continue;
			l_ind=it-dist[i];
			it=lower_bound(dist[i], dist[i]+-1, R+EPS);
			r_ind=it-dist[i]-1;
			if (l_ind<=r_ind)
				ans+=r_ind-l_ind+1;
		}
		//
		/*
		if (ans==per(n, Px, Py))
			cerr<<"OK ";
		else
			cerr<<"WA ans = "<<per(n, Px, Py)<<'\n';
		*/
		cout<<ans<<'\n';
	}
	return 0;
}

inline LD D(LD x, LD y, LD X, LD Y)
{
	return sqrt((X-x)*(X-x)+(Y-y)*(Y-y));
}

/*
int per(int n, LD Px, LD Py)
{
	int ret=0;
	for (int i=0; i<n; i++)
	{
		for (int j=i+1; j<n; j++)
		{
			long double dst[3]={D(Px, Py, x[i], y[i]),
			D(Px, Py, x[j], y[j]), D(x[i], y[i], x[j], y[j])};
			if (abs(dst[0]-dst[1])<EPS || abs(dst[1]-dst[2])<EPS
				|| abs(dst[0]-dst[2])<EPS)
					ret++;
		}
	}
	return ret;
}
*/
/*
4 1000
0 0
0 1
1 0
1 1

0 0
*/
