#include<iostream>
#include<algorithm>
#include<queue>
#include<cmath>
using namespace std;
struct point
{
    double x,y;
};
point pts[10000];
double dists[10000];
double all[1000000];
double eps=0.0003;
bool cmp(double a,double b)
{
    if(a+0.000000001<b)
    {
        return 0;
    }
    return 1;
}
int main()
{
    std::cin.tie(nullptr);
    std::ios::sync_with_stdio(false);
    int n,m;
    cin>>n>>m;
    for(int i=0; i<n; i++)
    {
        cin>>pts[i].x>>pts[i].y;
    }
    for(int i=0; i<m; i++)
    {
        point curr;
        cin>>curr.x>>curr.y;
        /*for(int j=0; j<n; j++)
        {
            dists[j]=sqrt((curr.x-pts[j].x)*(curr.x-pts[j].x)+(curr.y-pts[j].y)*(curr.y-pts[j].y));
        }
        sort(dists,dists+n);
        long long ans=0;
        queue<double>lens;
        for(int j=0; j<n; j++)
        {
            double a=dists[j];
            while(!lens.empty() && lens.front()+eps<a)
            {
                lens.pop();
            }
            ans+=lens.size();
            lens.push(a);
        }*/
        long long ans=0;
        for(int j=0; j<n; j++)
        {
            for(int k=0; k<n; k++)
            {
                double dax=curr.x-pts[j].x,day=curr.y-pts[j].y,dbx=pts[j].x-pts[k].x,dby=pts[j].y-pts[k].y;
                if(dax*dax+day*day+eps>dbx*dbx+dby*dby && dax*dax+day*day-eps<dbx*dbx+dby*dby){
                    ans++;
                }
            }
        }
        for(int j=0; j<n; j++)
        {
            for(int k=j+1; k<n; k++)
            {
                double dax=curr.x-pts[j].x,day=curr.y-pts[j].y,dbx=curr.x-pts[k].x,dby=curr.y-pts[k].y;
                if(dax*dax+day*day+eps>dbx*dbx+dby*dby && dax*dax+day*day-eps<dbx*dbx+dby*dby){
                    ans++;
                }
            }
        }
        cout<<ans<<endl;
    }
    return 0;
}
