#include<iostream>
#include<algorithm>
#include<queue>
#include<cmath>
using namespace std;
struct point
{
    double x,y;
};
point pts[10000];
double dists[10000];
double all[1000000];
double eps=0.0001;
bool cmp(double a,double b)
{
    if(a+0.000000001<b)
    {
        return 0;
    }
    return 1;
}
int main()
{
    std::cin.tie(nullptr);
    std::ios::sync_with_stdio(false);
    int n,m;
    cin>>n>>m;
    for(int i=0; i<n; i++)
    {
        cin>>pts[i].x>>pts[i].y;
    }
    for(int i=0; i<m; i++)
    {
        point curr;
        cin>>curr.x>>curr.y;
        long long ans=0;
        /*for(int j=0;j<n;j++){
            for(int k=j+1;k<n;k++){
                double a=sqrt((curr.x-pts[j].x)*(curr.x-pts[j].x)+(curr.y-pts[j].y)*(curr.y-pts[j].y));
                double b=sqrt((curr.x-pts[k].x)*(curr.x-pts[k].x)+(curr.y-pts[k].y)*(curr.y-pts[k].y));
                double c=sqrt((pts[k].x-pts[j].x)*(pts[k].x-pts[j].x)+(pts[k].y-pts[j].y)*(pts[k].y-pts[j].y));
                if(a+eps>b && a-eps<b){
                    ans++;
                }
                if(a+eps>c && a-eps<c){
                    ans++;
                }
                if(c+eps>b && c-eps<b){
                    ans++;
                }
            }
        }*/
        for(int j=0;j<n;j++){
            dists[j]=sqrt((curr.x-pts[j].x)*(curr.x-pts[j].x)+(curr.y-pts[j].y)*(curr.y-pts[j].y));
        }
        sort(dists,dists+n);
        queue<double>lens;
        for(int j=0;j<n;j++){
            double a=dists[j];
            while(!lens.empty() && lens.front()+eps<a){
                lens.pop();
            }
            ans+=lens.size();
            lens.push(a);
        }
        for(int j=0;j<n;j++){
            for(int k=j+1;k<n;k++){
                double a=sqrt((curr.x-pts[j].x)*(curr.x-pts[j].x)+(curr.y-pts[j].y)*(curr.y-pts[j].y));
                double b=sqrt((curr.x-pts[k].x)*(curr.x-pts[k].x)+(curr.y-pts[k].y)*(curr.y-pts[k].y));
                double c=sqrt((pts[k].x-pts[j].x)*(pts[k].x-pts[j].x)+(pts[k].y-pts[j].y)*(pts[k].y-pts[j].y));
                /*if(a+eps>b && a-eps<b){
                    ans++;
                }*/
                if(a+eps>c && a-eps<c){
                    ans++;
                }
                if(c+eps>b && c-eps<b){
                    ans++;
                }
            }
        }
        cout<<ans<<endl;
    }
    return 0;
}
