#include<bits/stdc++.h>

//#pragma GCC optimize("O3")

using namespace std;

const int MAXN = 1007;
const double eps = 0.005;

pair<double, double> p[MAXN];
double d[MAXN];
double arr[MAXN][MAXN];
int n;

int binary_search_1(int ind, double x)
{
    int l = -1, r = n-1, mid;

    while(l != r)
    {
        mid = (l+r+1)/2;

        if(arr[ind][mid] < x)
            l = mid;
        else
            r = mid-1;
    }

    return l;
}

int binary_search_2(int ind, double x)
{
    int l = 0, r = n, mid;

    while(l != r)
    {
        mid = (l+r)/2;

        if(arr[ind][mid] > x)
            r = mid;
        else
            l = mid+1;
    }

    return l;
}

int main ()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    int q;

    cin >> n >> q;

    for(int i = 0; i < n; ++i)
        cin >> p[i].first >> p[i].second;

    for(int i = 0; i < n; ++i)
        for(int j = 0; j < n; ++j)
            arr[i][j] = (p[i].first - p[j].first)*(p[i].first - p[j].first) + (p[i].second - p[j].second)*(p[i].second - p[j].second);

    for(int i = 0; i < n; ++i)
        sort(arr[i], arr[i]+n);

    for(int i = 0; i < q; ++i)
    {
        pair<double, double> x;

        cin >> x.first >> x.second;

        for(long long j = 0; j < n; ++j)
            d[j] = (x.first - p[j].first)*(x.first - p[j].first) + (x.second - p[j].second)*(x.second - p[j].second);

        sort(d, d+n);

        int j = 0, res = 0;

        for(int k = 0; k < n; ++k)
        {
            while(d[k] - d[j] >= eps)
                ++j;

            res += k-j;
        }

        for(int j = 0; j < n; ++j)
        {
            double curr_dist = (x.first - p[j].first)*(x.first - p[j].first) + (x.second - p[j].second)*(x.second - p[j].second);
            int l = binary_search_1(j, curr_dist-eps);
            int r = binary_search_2(j, curr_dist+eps);

            ++l;
            --r;

            if(l <= r)
                res += r-l+1;
        }

        cout << res << "\n";
    }

    return 0;
}
