#include<bits/stdc++.h>

using namespace std;

const long long big_number = 1e8;
const long long mod = 998244353;
const long long MAXN = 2e5 + 7;

long long a[MAXN];
map<long long, map<long long, long long> > cnt;
long long last[big_number];
long long pr[big_number];

long long solve(long long l, long long r)
{
    long long res = 0;

    for(long long i = l; i <= r; ++i)
    {
        for(long long j = i; j <= r; j++)
        {
            last[a[j]] = 0;
            pr[a[j]] = i-1;
        }

        for(long long j = i; j <= r; ++j)
        {
            long long used = last[a[j]];
            long long prev = pr[a[j]];

            if(cnt[a[j]].find(i-j+used*2) != cnt[a[j]].end())
                res += cnt[a[j]][i-j+used*2]*a[j]*max(j-prev-3, 0ll);
            for(long long k = 0; k <= min(3ll, j-prev); k++)
                if(cnt[a[j]].find(i-prev-k+used*2) != cnt[a[j]].end())
                    res += cnt[a[j]][i-prev-k+used*2]*a[j];

            cnt[a[j]][i-j+used*2+1] ++;
            cnt[a[j]][i-j+used*2] ++;
            cnt[a[j]][i-r+used*2-1] --;
            cnt[a[j]][i-r+used*2] --;

            last[a[j]]++;
            pr[a[j]] = j;

            res %= mod;

            //cout << res << " ";
        }
        //cout << endl << endl;

        res += a[i];

        res %= mod;

        //cout << res << endl;

        for(long long j = i; j <= r; ++j)
            cnt[a[j]].clear();
    }

    return res;
}

int main ()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    long long n, m;

    cin >> n;

    for(long long i = 1; i <= n; ++i)
        cin >> a[i];

    cin >> m;

    long long last_output = 0;

    for(long long i = 0; i < m; ++i)
    {
        long long l, r, t;

        cin >> l >> r >> t;

        long long type = ((t+last_output)%2)+1;
        long long p, q;

        if(type == 1)
        {
            p = ((l+last_output)%n)+1;
            q = ((r+last_output)%big_number)+1;
        }
        else
        {
            p = ((l+last_output)%n)+1;
            q = ((r+last_output)%n)+1;
        }

        if(type == 1)
        {
            a[p] = q;
        }
        else
        {
            long long res = solve(p, q);

            cout << res << "\n";

            last_output = res;
        }
    }

    return 0;
}
