#include <bits/stdc++.h>
#define endl '\n'
#define MAXN 200000
#define MAXV 100000000
#define MOD 998244353
using namespace std;
int n, m;
int arr[MAXN];

void input()
{
    cin >> n;

    for (int i = 0; i < n; i++)
        cin >> arr[i];
}

int cnt[MAXV][MAXN];

long long check(int l, int r)
{
    memset(cnt, 0, sizeof(cnt));

    for (int i = l; i <= r; i++)
        cnt[arr[i]]++;

    for (int i = l; i <= r; i++)
    {
       //cout << cnt[arr[i]] << endl;
        if (2 * cnt[arr[i]] > r - l + 1)
            return arr[i];
    }
    return 0;
}

long long ans(int l, int r)
{
    long long answ = 0;

    for (int i = l; i <= r; i++)
        for (int j = i; j <= r; j++)
        {
            //cout << i << " - " << j << endl;
            //cout << check(i, j) << endl;
            answ += check(i, j);
            answ %= MOD;
        }
    return answ;
}

void solve()
{
    int last_output = 0;
    cin >> m;

    for (int i = 0; i < m; i++)
    {
        int t, l, r;
        cin >> l >> r >> t;

        t = (t + last_output) % 2 + 1;

        //cout << "!" << t << endl;

        if (t == 1)
        {
            l = (l + last_output) % n;
            r = ((r + last_output) % MAXV) + 1;
            //cout << l << " " << r << endl;
            arr[l] = r;
        }
        else
        {
            l = (l + last_output) % n;
            r = (r + last_output) % n;
            //cout << l << " " << r << endl;
            //cout << "_________________" << endl;
            last_output = ans(l, r);
            cout << last_output << endl;
        }
    }
}

/*
4
1 2 2 1
3
4 3 1
2 99999990 2
4 2 1
*/

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    input();
    solve();

    return 0;
}
