#include <iostream>
#include <cmath>
using namespace std;
double x[1001], y[1001], qx, qy;
double modul(double x) {
    if (x<0) x=-x;
    return x;
}
bool check(int i, int j) {
    if ((x[i]==x[j] and y[i]==y[j]) or (x[j]==qx and y[j]==qy) or (qx==x[i] and qy==y[i])) return false;
    double s1, s2, s3;
    s1=sqrt((x[i]-x[j])*(x[i]-x[j])+(y[i]-y[j])*(y[i]-y[j]));
    s2=sqrt((x[i]-qx)*(x[i]-qx)+(y[i]-qy)*(y[i]-qy));
    s3=sqrt((qx-x[j])*(qx-x[j])+(qy-y[j])*(qy-y[j]));
    if (modul(s1-s2)<0.0001 or modul(s1-s3)<0.0001 or modul(s2-s3)<0.0001) {
        return true;
    }
    return false;
}
int main () {
    int n, q;
    cin >> n >> q;
    for (int i=0;i<n;i++) {
        cin >> x[i] >> y[i];
    }
    int ans;
    for (int i=0;i<q;i++) {
        cin >> qx >> qy;
        ans=0;
        for (int j=0;j<n;j++) {
            for (int k=0;k<n;k++) {
                if (check(j,k)) {
                    ans++;
                }
            }
        }
        cout << ans/2 << endl;
    }
    return 0;
}
