#include <bits/stdc++.h>
#define endl '\n'
#define TRACE(x) cerr << #x << " = " << x << endl

using namespace std;
template<class T, class T1> inline bool chkmax(T &x, const T1 &y) { return x < y ? x = y, true : false; }
template<class T, class T1> inline bool chkmin(T &x, const T1 &y) { return x > y ? x = y, true : false; }

const double EPS = 0.0001;
const double EPS2 = 1e-12;
const int MAXN = 1000;

struct Point {
    double x;
    double y;

    void read() {
        double x, y;
        cin >> x >> y;
        this->x = x;
        this->y = y;
    }

    bool operator <(const Point &other) const {
        if (fabs(this->x - other.x) < EPS2) return this->y < other.y;
        return this->x < other.x;
    }
};

ostream& operator <<(ostream &os, const Point &p) {
    return os << '(' << p.x << ", " << p.y << ')';
}

int n, q;
Point a[MAXN];

void read() {
    cin >> n >> q;
    for (int i = 0; i < n; i++) a[i].read();
}

double getLength(Point a, Point b) {
    double x = fabs(a.x - b.x);
    double y = fabs(a.y - b.y);
    return sqrt(x * x + y * y);
}

int ans;

void binarySearch1(Point a, int low, int high) {
    if (low == high) {
        for (int i = 0; i < n; i++) {
            if (i == low) continue;
            double l1 = getLength(a, ::a[low]);
            double l2 = getLength(a, ::a[i]);
            double l3 = getLength(::a[low], ::a[i]);
            double diff1 = fabs(l1 - l2);
            double diff2 = fabs(l1 - l3);
            double diff3 = fabs(l2 - l3);
            if (diff1 < EPS || diff2 < EPS || diff3 < EPS) ans++;
        }
        return;
    }
    int mid = (low + high) >> 1;
    binarySearch1(a, low, mid);
    binarySearch1(a, mid + 1, high);
}

void solve() {
    sort(a, a + n);
    Point curr;
    for (int i = 0; i < q; i++) {
        curr.read();
        ans = 0;
        binarySearch1(curr, 0, n - 1);
        cout << (ans >> 1) << endl;
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();

    return EXIT_SUCCESS;
}

