#include <bits/stdc++.h>
#define endl '\n'
#define TRACE(x) cerr << #x << " = " << x << endl

using namespace std;
template<class T, class T1> inline bool chkmax(T &x, const T1 &y) { return x < y ? x = y, true : false; }
template<class T, class T1> inline bool chkmin(T &x, const T1 &y) { return x > y ? x = y, true : false; }

const int MAXN = 10001;
const int MAX_VALUE = 20001;
const int MOD = 998244353;

struct Element {
    int val;
    int cnt;

    Element(int val, int cnt) {
        this->val = val;
        this->cnt = cnt;
    }

    bool operator <(const Element &other) const {
        return this->cnt < other.cnt;
    }
};

int n;
int m;

void read() {
}

map<int, int> compressed;
map<int, int> reverseCompressed;
int timestamp = 0;

inline int getNumber(int v) {
    if (!compressed.count(v)) {
        compressed[v] = ++timestamp;
        reverseCompressed[timestamp] = v;
    }
    return compressed[v];
}

int a[MAXN];
int cnt[MAX_VALUE], cnt2[MAX_VALUE];

int query(int l, int r) {
    memset(cnt, 0, sizeof(cnt));
    for (int i = l; i <= r; i++) {
        for (int j = 1; j <= timestamp; j++) cnt2[j] = 0;
        int m = 0;
        int val;
        for (int j = i; j <= r; j++) {
            cnt2[a[j]]++;
            if (chkmax(m, cnt2[a[j]])) val = a[j];
            int len = j - i + 1;
            if (m > len - m) {
                cnt[val]++;
                if (cnt[val] >= MOD) cnt[val] -= MOD;
            }
        }
    }
    int ans = 0;
    for (int i = 1; i <= timestamp; i++) ans = (ans + ((long long)reverseCompressed[i] * cnt[i]) % MOD) % MOD;
    return ans;
}

void solve() {
    compressed.clear();
    reverseCompressed.clear();
    cin >> n;
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
        a[i] = getNumber(a[i]);
    }
    int lastOutput = 0;
    cin >> m;
    for (int i = 1; i <= m; i++) {
        int l, r, t;
        cin >> l >> r >> t;
        int type = ((t + lastOutput) & 1) + 1;
        if (type == 1) {
            int p = ((l + lastOutput) % n) + 1;
            int q = ((r + lastOutput) % 100000000) + 1;
            compressed[a[p]]--;
            if (!compressed[a[p]]) {
                reverseCompressed.erase(reverseCompressed.find(compressed[a[p]]));
                compressed.erase(compressed.find(a[p]));
            }
            a[p] = getNumber(q);
        }
        else {
            int p = ((l + lastOutput) % n) + 1;
            int q = ((r + lastOutput) % n) + 1;
            lastOutput = query(p, q);
            cout << lastOutput << endl;
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();

    return EXIT_SUCCESS;
}

