#include <bits/stdc++.h>
#define endl '\n'
#define TRACE(x) cerr << #x << " = " << x << endl

using namespace std;
template<class T, class T1> inline bool chkmax(T &x, const T1 &y) { return x < y ? x = y, true : false; }
template<class T, class T1> inline bool chkmin(T &x, const T1 &y) { return x > y ? x = y, true : false; }
typedef long long ll;

const int MAX_COORD = 100;

int n;

void read() {
    cin >> n;
}

ll ans = 0ll;
bool used[MAX_COORD][MAX_COORD];
int dr[4] = {0, -1, 0, 1};
int dc[4] = {-1, 0, 1, 0};
//vector<pair<int, int>> v;

void F(int idx, int x, int y, int cntV) {
    //v.push_back({x, y});
    if (idx == n) {
        /*cerr << "New path found:\n";
        for (pair<int, int> it : v) cerr << it.first << ' ' << it.second << endl;
            */
        int cnt = 0;
        for (int i = 0; i < 4; i++) {
            int nx = x + dr[i];
            int ny = y + dc[i];
            if (used[nx][ny]) cnt++;
        }
        if (cnt == 4) ans++;
        //v.pop_back();
        return;
    }
    used[x][y] = true;
    for (int i = 0; i < 4; i++) {
        int nx = x + dr[i];
        int ny = y + dc[i];
        if (!used[nx][ny]) {
            if (i & 1) F(idx + 1, nx, ny, cntV);
            else if (i == 2) F(idx + 1, nx, ny, cntV + 1);
            else if (cntV) F(idx + 1, nx, ny, cntV + 1);
        }
    }
    used[x][y] = false;
    //v.pop_back();
}

void solve() {
    memset(used, false, sizeof(used));
    used[0][0] = true;
    //v.clear();
    F(1, 1, 0, 0);
    cout << ans << endl;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();

    return EXIT_SUCCESS;
}
