#include <iostream>
#include <map>
#define endl '\n'
using namespace std;

///Declare functions
void decrypt(int l, int r, int t);
void update(int p, int q);
void query(int p, int q);
int findMajorant(int l, int r);

int n;
const int MAXN = 200200;///200 000
int a[MAXN];
int m;
int lastOutput;
const int MOD_QUERY = 998244353;
const int MAXM = 128;
int b[MAXN];
int gAns[MAXM];
int gi;

map<int, int> numOcc;///numOcc[i][j] - number of occurrances of i up to the jth position in the array

int findMajorant(int l, int r) {
	map<int, int>nO;
	int mx = 0;
	int mxD = 0;
	for(int i = l;i <= r; ++i) {
		//cout << b[i] << " ";
		nO[b[i]] ++;
		if(nO[b[i]] > mx) {
			mx = nO[b[i]];
			mxD = b[i];
		}
	}
	//cout << "mx: " << mx << " " << mxD << endl;
	if(mx > (r - l + 1) / 2)
		return mxD;
	return 0;
}

void query(int p, int q) {
	//cout << "query p=" << p << " q=" << q << endl;
	/*for(int i = 0;i < n; ++i) {
		cout << a[i] << " ";
	}
	cout << endl;*/
	//numOcc.clear();
	int bi = 0;///Iterator for b[]
	for(int i = p;i <= q; ++i) {
		b[bi] = a[i - 1];
		++bi;
	}
	int bSz = bi;

	int ans = 0;
	//cout << bSz << endl;
	//cout << solve(1, bSz) << endl;
	/*for(int i = 0;i < bSz; ++i)
		cout << b[i] << endl;*/
	///Trivial solution
	for(int l = 0;l < bSz; ++l) {
		for(int r = l; r < bSz; ++r) {
			ans += findMajorant(l, r);
		}
	}
    gAns[gi] = ans;
	//cout << ans << endl;
	lastOutput = ans;
}

void update(int p, int q) {
	a[p - 1] = q;
	gAns[gi] = -1;
}

void decrypt(int l, int r, int t) {
	int p, q;
	t = ( (t + lastOutput) % 2) + 1;
	if(t == 1) {
		p = ( (l + lastOutput) % n ) + 1;
		q = ( (r + lastOutput) % 100000000) + 1;///100 000 000
		update(p, q);
	}
	else {
		p = ( (l + lastOutput) % n ) + 1;
		q = ( (r + lastOutput) % n ) + 1;
		query(p, q);
	}
}



int main() {
    cin >> n;
    for(int i = 0;i < n; ++i)
		cin >> a[i];
	cin >> m;
	int l, r, t;
	for(gi = 0;gi < m; ++gi) {
		cin >> l >> r >> t;
		decrypt(l, r, t);
	}
	for(int i = 0;i < m; ++i)
        if(gAns[i] != -1)
            cout << gAns[i] << endl;
    return 0;
}
