#include <iostream>
#include <cmath>
using namespace std;
double dabs(double a)
{
    if (a<0) return (-a);
    return a;
}
double r(double x1, double y1, double x2, double y2)
{
    double c=dabs(x1-x2)*dabs(x1-x2)+dabs(y1-y2)*dabs(y1-y2);
    return sqrt(c);
}
int main()
{
    int n, q;
    cin>>n>>q;
    double x[1024], y[1024], x1, y1;
    for (int i=0; i<n; i++)
        cin>>x[i]>>y[i];
    const double d=0.0001;
    for (int k=0; k<q; k++)
    {
        cin>>x1>>y1;
        int br=0;
        for (int i=0; i<n; i++)
        {
            for (int j=i+1; j<n; j++)
            {
                double a, b, c;
                a=r(x1, y1, x[i], y[i]);
                b=r(x1, y1, x[j], y[j]);
                c=r(x[i], y[i], x[j], y[j]);
                if (dabs(a-c)<d) br++;
                if (dabs(b-c)<d) br++;
                if (dabs(a-b)<d) br++;
            }
        }
        cout<<br<<endl;
    }
}
