#include <bits/stdc++.h>
using namespace std;

const int MAXN=1e3+10;
const double eps=0.0001;
const int inf=1e9+2137;

pair<double,double> punkt[MAXN];

double dist[MAXN][MAXN];
int pos[MAXN];
double dist2[MAXN];

double calc(pair<double,double> a,pair<double,double> b)
{
    return abs(a.first-b.first)*abs(a.first-b.first)+abs(a.second-b.second)*abs(a.second-b.second);
}

int lower(double odl,int tab)
{
    odl-=eps;
    int lo=0;
    int hi=pos[tab]-1;
    int mid,ans=inf;
    while(lo<=hi)
    {
        mid=(lo+hi)/2;
        if(dist[tab][mid]>=odl)
        {
            ans=mid;
            hi=mid-1;
        }
        else
            lo=mid+1;
    }
    return ans;
}

int upper(double odl,int tab)
{
    odl+=eps;
    int lo=0;
    int hi=pos[tab]-1;
    int mid,ans=-inf;
    while(lo<=hi)
    {
        mid=(lo+hi)/2;
        if(dist[tab][mid]<=odl)
        {
            ans=mid;
            lo=mid+1;
        }
        else
            hi=mid-1;
    }
    return ans;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n,i,j,q,ans,l,r,nxt,ile;
    double a,b,odl,val;
    cin>>n>>q;
    for(i=0;i<n;i++)
    {
        cin>>a>>b;
        punkt[i].first=a;
        punkt[i].second=b;
        for(j=0;j<i;j++)
        {
            dist[i][pos[i]]=calc(punkt[i],punkt[j]);
            dist[j][pos[j]]=calc(punkt[i],punkt[j]);
            pos[i]++;
            pos[j]++;
        }
    }
    for(i=0;i<n;i++)
    {
        sort(dist[i],dist[i]+n-1);
    }
    for(i=0;i<q;i++)
    {
        cin>>a>>b;
        ans=0;
        for(j=0;j<n;j++)
        {
            dist2[j]=calc(make_pair(a,b),punkt[j]);
        }
        sort(dist2,dist2+n);
        nxt=0;
        for(j=0;j<n;j++)
        {
            nxt=max(nxt,j);
            while(nxt<n&&dist2[nxt]-dist2[j]<=eps)
            {
                nxt++;
            }
            ans+=nxt-j-1;
        }
        for(j=0;j<n;j++)
        {
            odl=calc(make_pair(a,b),punkt[j]);
            l=lower(odl,j);
            r=upper(odl,j);
            ans+=max(0,r-l+1);
        }
        cout<<ans<<"\n";
    }
}
