#include <bits/stdc++.h>
using namespace std;

const int MAXN=1e3+10;
const float eps=0.0001;
const int inf=1e9+2137;

pair<float,float> punkt[MAXN];

vector<float> dist[MAXN];
float dist2[MAXN];

float calc(pair<float,float> a,pair<float,float> b)
{
    return sqrt(abs(a.first-b.first)*abs(a.first-b.first)+abs(a.second-b.second)*abs(a.second-b.second));
}

int lower(float odl,int tab)
{
    odl-=eps;
    int lo=0;
    int hi=dist[tab].size()-1;
    int mid,ans=inf;
    while(lo<=hi)
    {
        mid=(lo+hi)/2;
        if(dist[tab].at(mid)>=odl)
        {
            ans=mid;
            hi=mid-1;
        }
        else
            lo=mid+1;
    }
    return ans;
}

int upper(float odl,int tab)
{
    odl+=eps;
    int lo=0;
    int hi=dist[tab].size()-1;
    int mid,ans=-inf;
    while(lo<=hi)
    {
        mid=(lo+hi)/2;
        if(dist[tab].at(mid)<=odl)
        {
            ans=mid;
            lo=mid+1;
        }
        else
            hi=mid-1;
    }
    return ans;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n,i,j,q,ans,l,r,nxt,ile;
    float a,b,odl,val;
    cin>>n>>q;
    for(i=0;i<n;i++)
    {
        cin>>a>>b;
        punkt[i].first=a;
        punkt[i].second=b;
        for(j=0;j<i;j++)
        {
            dist[i].push_back(calc(punkt[i],punkt[j]));
            dist[j].push_back(calc(punkt[i],punkt[j]));
        }
    }
    for(i=0;i<n;i++)
    {
        sort(dist[i].begin(),dist[i].end());
    }
    for(i=0;i<q;i++)
    {
        cin>>a>>b;
        ans=0;
        for(j=0;j<n;j++)
        {
            dist2[j]=calc(make_pair(a,b),punkt[j]);
        }
        sort(dist2,dist2+n);
        nxt=0;
        for(j=0;j<n;j++)
        {
            nxt=max(nxt,j);
            while(nxt<n&&dist2[nxt]-dist2[j]<=eps)
            {
                nxt++;
            }
            ans+=nxt-j-1;
        }
        for(j=0;j<n;j++)
        {
            odl=calc(make_pair(a,b),punkt[j]);
            l=lower(odl,j);
            r=upper(odl,j);
            ans+=max(0,r-l+1);
        }
        cout<<ans<<"\n";
    }
}
