#include <bits/stdc++.h>

using namespace std;

#define double long double

const int FLOR = 1e5;
const int MAXN = 1000;


double x[MAXN + 1], y[MAXN + 1];


double pit (double x1, double y1, double x2, double y2) {
  return sqrt ((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2));
}

unordered_map <long long, int> mp;
unordered_map <long long, int> mup[MAXN + 1];


int main() {


  int n, q, i, j;

  //freopen ("triangle.in", "r", stdin);
  //freopen ("triangle.out", "w", stdout);
  cin >> n >> q;
  for (i = 1; i <= n; i++) {
    cin >> x[i] >> y[i];
    x[i] = x[i] * FLOR;
    y[i] = y[i] * FLOR;
  }

  for (i = 1; i <= n; i++) {
    for (j = i + 1; j <= n; j++) {
      double e = pit (x[i], y[i], x[j], y[j]);
   //   cout << e << '\n';
      long long t = e;
      //cout << t << '\n';

      if (t % 10 >= 5)
        t = t - t % 10 + 10;
      else
        t = t - t % 10;
      mup[i][t]++;
      mup[j][t]++;
    }
  }
  //cout << '\n';
  while (q--) {
    int sol = 0;
    double xx, yy;
    cin >> xx >> yy;
    xx = xx * FLOR;
    yy = yy * FLOR;
    // case 1
    mp.clear ();
    for (i = 1; i <= n; i++) {
      double e = pit (x[i], y[i], xx, yy);

      //if (q == 1)

      long long t = e;

     // cout << t << ' ';
      if (t % 10 >= 5)
        t = t - t % 10 + 10;
      else
        t = t - t % 10;
    //  cout << t << ' ';
      sol = sol + mp[t];
      mp[t]++;
    }

    // case 2
    for (i = 1; i <= n; i++) {
      double e = pit (x[i], y[i], xx, yy);
      long long t = e;
      if (t % 10 >= 5)
        t = t - t % 10 + 10;
      else
        t = t - t % 10;
      sol = sol + mup[i][t];
    }

    cout << sol << '\n';
  }
  return 0;
}
