/**
Task 3.
Triangle
**/
#include <iostream>
#include <cmath>
#include <map>
#include <cstdio>

using namespace std;

typedef long double ld;

const ld EPS=0.0001;

struct point
{
    ld x;
    ld y;
};

inline ld dist(point a,point b)
{
    ld dx=a.x-b.x;
    ld dy=a.y-b.y;
    return sqrt(dx*dx+dy*dy);
}

const int N=1000+5;

int n,t;
point v[N];

struct DD
{
    ld a;
};

bool operator < (DD x,DD y)
{
    return x.a-y.a<-EPS;
}

map<DD,int>fid[N];

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    cin>>n>>t;
    for(register int i=1;i<=n;i++)
    {
        cin>>v[i].x>>v[i].y;
    }
    DD aux;
    for(register int i=1;i<=n;i++)
    {
        for(register int j=1;j<=n;j++)
        {
            if(i!=j)
            {
                aux.a=dist(v[i],v[j]);
                fid[i][aux]++;
            }
        }
    }
    point p;
    int ans;
    map<DD,int>f;
    for(register int tc=1;tc<=t;tc++)
    {
        cin>>p.x>>p.y;
        ans=0;
        f.clear();
        for(int i=1;i<=n;i++)
        {
            aux.a=dist(p,v[i]);
            ans+=f[aux]++;
            ans+=fid[i][aux];
        }
        cout<<ans<<"\n";
    }
    return 0;
}
