/**
Task2 : Majorant
**/
#include <iostream>
#include <map>
#include <cstdio>

using namespace std;

const int N=200000+5;
const int MOD=998244353;

int n;
int aib[2*N];

inline void add(int p,int x)
{
    for(int i=p;i<N;i+=i&(-i))
    {
        aib[i]+=x;
    }
}

inline int prefix(int p)
{
    int ans=0;
    for(int i=p;i>=1;i-=i&(-i))
    {
        ans+=aib[i];
    }
    return ans;
}

map<int,int>de;
int what[N],cnt=0;
int v[N];

inline int ask(int st,int dr)
{
    int res=0;
    n+=2;
    for(int x=1;x<=cnt;x++)
    {
        for(int i=1;i<=2*n;i++)
        {
            aib[i]=0;
        }
        int sol=0;
        int cur=n;
        add(cur,1);
        for(int i=st;i<=dr;i++)
        {
            if(v[i]==x)
            {
                cur++;
            }
            else
            {
                cur--;
            }
            sol+=prefix(cur-1);
            add(cur,1);
        }
        res=(res+sol*what[x])%MOD;
    }
    n-=2;
    return res;
}

inline void upd(int p,int x)
{
    if(de[x]==0)
    {
        de[x]=++cnt;
        what[cnt]=x;
    }
    v[p]=de[x];
}

int lstop=0;

inline void go()
{
    int l,r,t;
    cin>>l>>r>>t;
    int type=(t+lstop)%2+1,p,q;
    if(type==1)
    {
        p=(l+lstop)%n+1;
        q=(r+lstop)%100000000+1;
        upd(p,q);
    }
    else
    {
        p=(l+lstop)%n+1;
        q=(r+lstop)%n+1;
        lstop=ask(p,q);
        cout<<lstop<<"\n";
    }
}

int main()
{
  //  freopen("innnn","r",stdin);
  //  freopen("ooo","w",stdout);
    cin>>n;
    for(int i=1;i<=n;i++)
    {
        int x;
        cin>>x;
        if(de[x]==0)
        {
            de[x]=++cnt;
            what[cnt]=x;
        }
        v[i]=de[x];
    }
    int q;
    cin>>q;
    for(int i=1;i<=q;i++)
    {
        go();
    }
    return 0;
}
/**

**/
