/**
Task2 : Majorant
**/
#include <iostream>
#include <map>
#include <cstdio>

using namespace std;

const int N=10000+5+5;
const int MOD=998244353;

inline int add(int a,int b)
{
    a+=b;
    if(a>=MOD)
    {
        a-=MOD;
    }
    if(a<0)
    {
        a+=MOD;
    }
    return a;
}

inline int mul(int a,int b)
{
    return a*(long long)b%MOD;
}

int aib[2*N];

inline void addd(int p,int x)
{
    for(int i=p;i<2*N;i+=i&(-i))
    {
        aib[i]+=x;
    }
}

inline int prefix(int p)
{
    int ans=0;
    for(int i=p;i>=1;i-=i&(-i))
    {
        ans+=aib[i];
    }
    return ans;
}

inline void clr()
{
    for(int i=0;i<2*N;i++)
    {
        aib[i]=0;
    }
}

int n;
int v[N];
bool viz[N];

inline int ask(int st,int dr)
{
    int sol=0;
    for(int i=st;i<=dr;i++)
    {
        viz[i]=0;
    }
    n+=2;
    for(int i=st;i<=dr;i++)
    {
        if(viz[i]==0)
        {
            clr();
            int x=v[i];
            int cur=n;
            int ans=0;
            for(int p=st;p<=dr;p++)
            {
                addd(cur,1);
                if(v[p]==x)
                {
                    viz[p]=1;
                    cur++;
                }
                else
                {
                    cur--;
                }
                ans=add(ans,prefix(cur-1));
            }
            sol=add(sol,mul(x,ans));
        }
    }
    n-=2;
    return sol;
}

int lst=0;

inline void test()
{
    int l,r,t;
    cin>>l>>r>>t;
    int type=(t+lst)%2+1;
    int a,b;
    if(type==1)
    {
        a=(l+lst)%n+1;
        b=(r+lst)%100000000+1;
        v[a]=b;
    }
    else
    {
        a=(l+lst)%n+1;
        b=(r+lst)%n+1;
        lst=ask(a,b);
        cout<<lst<<"\n";
    }
}

int main()
{

  //  freopen("innnn","r",stdin);
  //  freopen("ooo","w",stdout);
    cin>>n;
    for(int i=1;i<=n;i++)
    {
        cin>>v[i];
    }
    int q;
    cin>>q;
    while(q--)
    {
        test();
    }
    return 0;
}
/**

**/
