/**
Task 3.
Triangle
**/
#include <iostream>
#include <cmath>

using namespace std;

typedef long double ld;

const ld EPS=0.0001;

struct point
{
    ld x;
    ld y;
};

inline ld dist(point a,point b)
{
    ld dx=a.x-b.x;
    ld dy=a.y-b.y;
    return sqrt(dx*dx+dy*dy);
}

const int N=1000+5;

int n,t;
point v[N];

inline bool eq(ld x,ld y)
{
    ld dif=fabs(x-y);
    if(dif<=EPS)
    {
        return 1;
    }
    else
    {
        return 0;
    }
}

inline bool is(point a,point b,point c)
{
    ld x=dist(a,b);
    ld y=dist(a,c);
    ld z=dist(b,c);
    if(eq(x,y) || eq(x,z) || eq(y,z))
    {
        return 1;
    }
    else
    {
        return 0;
    }
}

int main()
{
    cin>>n>>t;
    for(int i=1;i<=n;i++)
    {
        cin>>v[i].x>>v[i].y;
    }
    for(int tc=1;tc<=t;tc++)
    {
        point p;
        cin>>p.x>>p.y;
        int ans=0;
        for(int i=1;i<=n;i++)
        {
            for(int j=i+1;j<=n;j++)
            {
                if(is(p,v[i],v[j]))
                {
                    ans++;
                }
            }
        }
        cout<<ans<<"\n";
    }
    return 0;
}
