#include <bits/stdc++.h>

using namespace std;

typedef pair <double, double> pdd;
const double EPS = 1e-4;

int n, q, sol;
double x, y;

unordered_map <double, int> f;
pdd v[1005];

double sqr(double a) {
  return a * a;
}

double dist(pdd a, pdd b) {
  return sqrt(sqr(a.first - b.first) + sqr(a.second - b.second));
}

bool egal(double a, double b) {
  return (a + EPS == b || a == b + EPS);
}

int main() {
  cin >> n >> q;
  for(int i = 1; i <= n; i++)
    cin >> v[i].first >> v[i].second;
  for(; q; q--) {
    cin >> x >> y;
    sol = 0;
    for(int i = 1; i <= n; i++) {
      for(int j = 1; j <= n; j++) {
        if(i != j) {
          double a = dist(v[i], v[j]), b = dist(v[j], {x, y}), c = dist({x, y}, v[i]);
          if(egal(a, b) || egal(b, c) || egal(c, a)) {
            if(egal(a, b) && egal(b, c))
              continue;
            else
              sol++;
          }
        }
      }
    }
    cout << sol << "\n";
  }
  return 0;
}
