#include <bits/stdc++.h>

using namespace std;

const double eps = 0.0001;

struct punct
{
    double x, y;
};

punct a[1005], t;

int n, q;

double sg[1005][1005];

bool aux[1005];

long long sol;

double dist (punct a, punct b)
{
    return sqrt((b.x - a.x) * (b.x - a.x) + (b.y - a.y) * (b.y - a.y));
}

int main()
{
    cin >> n >> q;

    for (int i = 1; i <= n; i++)
    {
        cin >> a[i].x >> a[i].y;
    }

    for (int i = 1; i <= n; i++)
    {
        for (int j = 1; j <= n; j++)
        {
            if (i != j)
            {
                sg[i][j] = dist(a[i], a[j]);
            }
        }

        sort(sg[i] + 1, sg[i] + n + 1);
    }

    for (int i = 1; i <= q; i++)
    {
        sol = 0;
        cin >> t.x >> t.y;

        for (int j = 1; j <= n; j++)
        {
            if (t.x == a[j].x && t.y == a[j].y) aux[j] = true;
        }

        for (int j = 1; j <= n; j++)
        {
            double d = dist(t, a[j]);

            if (d == 0 || aux[j] == true) continue;

            int st = 2;
            int dr = n;

            int incint = 0;
            int sfint = -1;

            while (st <= dr)
            {
                int mij = (st + dr) / 2;
                double dif = sg[mij][j] - d;

                if (dif > eps)
                {
                    dr = mij - 1;
                }
                else
                {
                    bool ok = false;
                    if (dif < 0)
                    {
                        ok = true;
                        dif = -dif;
                    }

                    if (dif > eps)
                    {
                        st = mij + 1;
                    }
                    else
                    {
                        incint = mij;
                        dr = mij - 1;
                    }
                }
            }

            st = 2;
            dr = n;

            while (st <= dr)
            {
                int mij = (st + dr) / 2;
                double dif = sg[mij][j] - d;

                if (dif > eps)
                {
                    dr = mij - 1;
                }
                else
                {
                    bool ok = false;
                    if (dif < 0)
                    {
                        ok = true;
                        dif = -dif;
                    }

                    if (dif > eps)
                    {
                        st = mij + 1;
                    }
                    else
                    {
                        sfint = mij;
                        st = mij + 1;
                    }
                }
            }

            sol = sol + sfint - incint + 1;
        }

        cout << sol << '\n';

        for (int j = 1; j <= n; j++)
        {
            if (t.x == a[j].x && t.y == a[j].y) aux[j] = false;
        }
    }
    return 0;
}
