#include <bits/stdc++.h>

using namespace std;

const int NMAX=1e3+5;

const double eps=0.0001;

struct point
{
    double X, Y;
};

point A[NMAX];

double Dist (point A, point B)
{
    return ((A.X-B.X)*(A.X-B.X) + (A.Y-B.Y)*(A.Y-B.Y));
}

double Distances[NMAX];

int N, i, Q;

bool P[NMAX][NMAX];

vector <double> V;

double X, Y;

int main()
{
    cin.tie(NULL);

    cin>>N>>Q;

    for(i=1; i<=N; ++i)
        cin>>A[i].X>>A[i].Y;

    for(i=1; i<=Q; ++i)
    {
        cin>>X>>Y;

        for(int j=1; j<=N; ++j)
            for(int t=1; t<=N; ++t)
                P[j][t]=false;

        int ans=0;

        for(int j=1; j<N; ++j)
            for(int t=j+1; t<=N; ++t)
                if(P[j][t]==false && P[t][j]==false)
                {
                    double d1=Dist({X, Y}, A[j]);
                    double d2=Dist({X, Y}, A[t]);

                    if(d1==d2)
                    {
                        ans++;
                        P[j][t]=P[t][j]=1;
                    }

                    else
                    {
                        d1=Dist(A[i], {X, Y});
                        d2=Dist(A[i], A[j]);

                        if(d1==d2)
                        {
                            ans++;
                            P[j][t]=P[t][j]=1;
                        }
                        else
                        {
                            d1=Dist(A[j], {X, Y});
                            d2=Dist(A[j], A[i]);

                            if(d1==d2)
                            {
                                ans++;
                                P[j][t]=P[t][j]=1;
                            }
                        }
                    }
                }

        cout<<ans<<'\n';
    }

    return 0;
}
