#include <bits/stdc++.h>

#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")

using namespace std;

typedef long long ll;

#define float double

const char el = '\n';
const int inf = 1e9;
const ll llinf = 1e18, mod = (int)(1e9) + 7;
const float eps = 0.0001;

#define x first
#define y second
#define forn(i, n) for(int i = 0; i < (int)n; ++i)
#define firn(i, n) for(int i = 1; i < (int)n; ++i)
#define all(v) v.begin(), v.end()

mt19937 rnd(time(NULL));

struct pt {
    float x, y;
};
float dist(pt & a, pt & b) {
    return pow((a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y), 0.50);
}
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, q;
    cin >> n >> q;
    vector<pt> a(n);
    forn(i, n)
    cin >> [i].x >> cin a[i].y;
    vector<float> d[1000];
    forn(i, n) {
        forn(j, n) {
            if (j == i) continue;
            d[i].push_back(dist(a[i], a[j]));
        }
        sort(all(d[i]));
    }
    vector<float> tmp(n);
    while(q--) {
        pt b;
        cin >> b.x >> b.y;
        forn(i, n) tmp[i] = dist(a[i], b);
        sort(all(tmp));
        int l = 0, r = 0;
        int ans = 0;
        while(l < n) {
            if (r < l) r = l;
            while(r < n && tmp[r] - tmp[l] < eps)
                r++;
            r--;
            ans += r - l;
            l++;
        }
        float ras;
        forn(i, n) {
            ras = dist(a[i], b);
            auto l = lower_bound(all(d[i]), ras - eps), r = upper_bound(all(d[i]), ras + eps);
            ans += r - l;
        }
        cout << ans << '\n';
    }
    return 0;
}

