#include <bits/stdc++.h>

#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")

using namespace std;

typedef long long ll;

#define float double

const char el = '\n';
const int inf = 1e9;
const ll llinf = 1e18, mod = (int)(1e9) + 7;
const float eps = 0.0001;

#define x first
#define y second
#define forn(i, n) for(int i = 0; i < (int)n; ++i)
#define firn(i, n) for(int i = 1; i < (int)n; ++i)
#define all(v) v.begin(), v.end()

mt19937 rnd(time(NULL));

struct pt {
    float x, y;
};
float dist(float & a, float & b, float & c, float & d) {
    return pow((a - c) * (a - c) + (b - d) * (b - d), 0.5);
}
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, q;
    cin >> n >> q;
    vector<float> x(n), y(n);
    forn(i, n)
    cin >> x[i] >> y[i];
    vector<float> d[1000];
    forn(i, n) {
        forn(j, n) {
            if (j == i) continue;
            d[i].push_back(dist(x[i], y[i], x[j], y[j]));
        }
        sort(all(d[i]));
    }
    vector<float> tmp(n);
    while(q--) {
        float bx, by;
        cin >> bx >> by;
        int ans = 0;
        forn(i, n) {
            tmp[i] = dist(x[i], y[i], bx, by);
            auto l = lower_bound(all(d[i]), tmp[i] - eps), r = upper_bound(all(d[i]), tmp[i] + eps);
            ans += r - l;
        }
        sort(all(tmp));
        int l = 0, r = 0;
        while(l < n) {
            if (r < l) r = l;
            while(r < n && tmp[r] - tmp[l] < eps)
                r++;
            r--;
            ans += r - l;
            l++;
        }
        cout << ans << '\n';
    }
    return 0;
}

