#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("fast-math")
#include <bits/stdc++.h>

using namespace std;

#define ld double
#define ll long long
#define left left228
#define right right228

template<typename T> void uin(T &a, T b) {
	if (b < a) {
		a = b;
	}
}

template<typename T> void uax(T &a, T b) {
	if (b > a) {
		a = b;
	}
}

const int maxn = 1001;

const double eps = 0.0001;

int n, q;

double X[maxn], Y[maxn];

double dst[maxn];

vector<double> d[maxn];


signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cin >> n >> q;
	for (int i = 1; i <= n; ++i) {
		cin >> X[i] >> Y[i];
	}
	for (int i = 1; i <= n; ++i) {
		d[i].reserve(n);
		for (int j = 1; j <= n; ++j) {
			d[i].push_back(sqrt((X[i] - X[j]) * (X[i] - X[j]) + (Y[i] - Y[j]) * (Y[i] - Y[j])));
		}
		sort(d[i].begin(), d[i].end());
	}
	int res = 0;
	int r;
	double x, y;
	int cc;
	// int low, high;
	for (int iter = 0; iter < q; ++iter) {
		cin >> x >> y;
		res = 0;
		cc = 0;
		for (int i = 1; i <= n; ++i) {
			// dst[i] = get_dist(a, p[i]);
			dst[i] = sqrt((x - X[i]) * (x - X[i]) + (y - Y[i]) * (y - Y[i]));
			if (dst[i] < eps) {
				++cc;
				continue;
			}
			res += upper_bound(d[i].begin(), d[i].end(), dst[i] + eps) - lower_bound(d[i].begin(), d[i].end(), dst[i] - eps);
		}
		res += cc * (cc - 1) / 2;
		sort(dst + 1, dst + n + 1);
		r = 0;
		for (int i = 1; i <= n; ++i) {
			while (r + 1 <= n && dst[r + 1] - dst[i] < eps) ++r;
			res += r - i;
		}
		cout << res << '\n';
	}
	return 0;
}