#include <bits/stdc++.h>

using namespace std;
typedef long double ld;
#define pii pair<ld, ld>
#define x first
#define y second
const ld eps = 0.0001;

ld dist(pii a, pii b) {
    return sqrt((a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y));
}

pii curr;
vector<pii> a;
vector<int> sorted[1009];
bool cmp(int i, int j) {
    return dist(curr, a[i]) < dist(curr, a[j]);
}

signed main() {
    ios :: sync_with_stdio(0);
    cin.tie(0);

    int n, m;
    cin >> n >> m;
    a.resize(n);

    for (int i = 0;  i< n; i ++) {
        cin >> a[i].x >> a[i].y;

        for (int j = 0; j < n; j ++) {
            if (j != i)
                sorted[i].push_back(j);
        }
    }

    for (int i = 0; i < n; i ++) {
        curr = a[i];
        sort(sorted[i].begin(), sorted[i].end(), cmp);
        /*cout << i << endl;
        for (auto u : sorted[i]) {
            cout << u << ' ' << dist(a[i], a[u]) << endl;
        }*/
    }

    while (m--) {
        pii in;
        cin >> in.x >> in.y;
        int answ = 0;
        vector<int> b(n);

        for (int i = 0; i < n; i ++) {
            ld dini = dist(in, a[i]);
            b[i] = i;

            int l = -1, r = n - 1;
            while (r - l > 1) {
                int mid = (r + l) / 2;

                if (dist(a[i], a[sorted[i][mid]]) >= dini - eps) {
                    r = mid;
                }

                else {
                    l = mid;
                }
            }

            int gr1 = r;
            l = 0;
            r = n - 1;

            while (r - l > 1) {
                int mid = (r + l) / 2;

                if (dist(a[i], a[sorted[i][mid]]) > dini + eps) {
                    r = mid;
                }

                else {
                    l = mid;
                }
            }

            int gr2 = l;
            //cout << i << ' ' << dini << ' ' << gr1 << ' ' << gr2 << endl;
            //cout << a[i].x << ' ' << a[i].y << endl;
            if (gr2 == -1 || gr1 == n - 1) continue;
            answ += max(0, gr2 - gr1 + 1);
        }

        curr = in;
        sort(b.begin(), b.end(), cmp);
        /*for (auto u : b) {
            cout << a[u].x << ' ' << a[u].y << ' ' << dist(a[u], curr) << endl;
        }
        cout << endl;*/

        for (int i = 0; i < n; i ++) {
            ld dini = dist(in, a[b[i]]);

            int l = i, r = n;
            while (r - l > 1) {
                int mid = (r + l) / 2;

                if (dist(curr, a[b[mid]]) >= dini - eps) {
                    r = mid;
                }

                else {
                    l = mid;
                }
            }

            int gr1 = r;
            l = i;
            r = n;

            while (r - l > 1) {
                int mid = (r + l) / 2;

                if (dist(curr, a[b[mid]]) > dini + eps) {
                    r = mid;
                }

                else {
                    l = mid;
                }
            }

            int gr2 = l;
            //cout << a[b[i]].x << ' ' << a[b[i]].y << endl;
            if (gr2 == i || gr1 == n) continue;
            //cout << i << ' ' << dini << ' ' << gr1 << ' ' << gr2 << ' ' << dist(in, a[b[gr1]]) << ' ' << dist(in, a[b[gr2]]) << endl;
            answ += max(0, gr2 - gr1 + 1);
        }

        cout << answ << "\n";
    }

    return 0;
}
