#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#define ll long long
#define pb push_back
#define pii pair<int, int>
#define pdd pair<double, double>
#define ft first
#define sd second

using namespace std;

double dist (pdd a, pdd b) {
    return sqrt((a.ft - b.ft) * (a.ft - b.ft) + (a.sd - b.sd) * (a.sd - b.sd));
}

double eps = 0.0001;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, q;
    cin >> n >> q;
    vector<pdd> v(n);
    for (int i = 0; i < n; ++i) {
        cin >> v[i].ft >> v[i].sd;
    }

    vector<vector<double>> d(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            d[i].pb(dist(v[i], v[j]));

        }
        sort(d[i].begin(), d[i].end());
    }
    for (int o = 0; o < q; ++o) {
        pdd curr;
        cin >> curr.ft >> curr.sd;
        vector<double> len;
        int ans = 0;
        for (int i = 0; i < n; ++i) {
            len.pb(dist(curr, v[i]));
            ans += (upper_bound(d[i].begin(), d[i].end(), len[i] + eps) - lower_bound(d[i].begin(), d[i].end(), len[i] - eps));
        }
        //cout << ans << "\n";
        /*sort(len.begin(), len.end());
        int res = 0;
        for (int i = 0; i < n; ++i) {
            int x = (upper_bound(len.begin(), len.end(), len[i] + eps) - lower_bound(len.begin(), len.end(), len[i] - eps));
            res += (x - 1);
        }
        res /= 2;
        ans += res;*/
        cout << ans << "\n";
    }
    return 0;

    /*
    4 3
    0.0 5.0
    3.0 4.0
    4.0 3.0
    5.0 0.0

    5.0 5.0
    0.0 0.0
    0.0 9.0
    */
}
