#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#define ll long long
#define pb push_back
#define pii pair<int, int>
#define pdd pair<double, double>
#define ft first
#define sd second

using namespace std;

double dist (pdd a, pdd b) {
    return sqrt((a.ft - b.ft) * (a.ft - b.ft) + (a.sd - b.sd) * (a.sd - b.sd));
}

double eps = 0.0001;
pdd v[1000];
vector<double> d[1000];

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, q;
    cin >> n >> q;
    for (int i = 0; i < n; ++i) {
        cin >> v[i].ft >> v[i].sd;
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            d[i].pb(dist(v[i], v[j]));
        }
        sort(d[i].begin(), d[i].end());
    }
    pdd curr;
    vector<double> len(n);
    int res = 0;
    for (int o = 0; o < q; ++o) {
        cin >> curr.ft >> curr.sd;
        int ans = 0;
        for (int i = 0; i < n; ++i) {
            len[i] = dist(v[i], curr);
            //ans += (upper_bound(d[i].begin(), d[i].end(), len[i] + eps) - lower_bound(d[i].begin(), d[i].end(), len[i] - eps));
        }
        //cout << ans << "\n";
        res = 0;
        sort(len.begin(), len.end());
        int i = 0;
        int a = 0, b = 0;
        while (i < n) {
            while (len[a] + eps < len[i]) {
                ++a;
            }
            while (len[b] - eps <= len[i] && b < n) {
                ++b;
            }
            res += (b - a - 1);
            ++i;
        }
        res /= 2;
        ans += res;
        cout << ans << "\n";
    }
    return 0;

    /*
    4 3
    0.0 5.0
    3.0 4.0
    4.0 3.0
    5.0 0.0

    5.0 5.0
    0.0 0.0
    0.0 9.0
    */
}
