#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef unsigned long long ull;
typedef long double ld;

#define pb emplace_back
#define mp make_pair
#define fi first
#define se second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define EPS 1e-4
#define INF 1e9
#define gcd __gcd

inline void Routine() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

template<class U, class T>
istream &operator >> (istream &in, pair<U, T> &p) {
    in >> p.fi >> p.se;
    return in;
}

template<class U, class T>
ostream &operator << (ostream &out, const pair<U, T> &p) {
    out << p.fi << ' ' << p.se;
    return out;
}

template<class T>
istream &operator >> (istream &in, vector<T> &v) {
    for (auto &c : v) {
        in >> c;
    }
    return in;
}

template<class T>
ostream &operator << (ostream &out, const vector<T> &v) {
    for (auto &c : v) {
        out << c << ' ';
    }
    return out;
}

double distanc(pair<double, double> &a, pair<double, double> &b) {
    return sqrt((a.fi - b.fi) * (a.fi - b.fi) + (a.se - b.se) * (a.se - b.se));
}

signed main() {
    Routine();
    int n;
    cin >> n;
    vector<int> a(n);
    cin >> a;
    int p, q, m, t;
    ll last = 0;
    cin >> m;
    while (m--) {
        cin >> p >> q >> t;
        t = (t + last) % 2 + 1;
        if (t == 1) {
            p = (p + last) % n;
            q = (q + last) % 100000000 + 1;
            a[p] = q;
        } else {
            p = (p + last) % n;
            q = (q + last) % n;
            last = 0;
            for (int i = p; i <= q; i++) {
                last += a[i];
            }
            for (int sz = 2; sz <= q - p + 1; sz++) {
                unordered_map<int, int> m;
                for (int i = 0; i < sz; i++) {
                    m[a[i]]++;
                }
                set<pair<int, int> > s;
                for (auto &c : m) {
                    s.emplace(c.se, c.fi);
                }
                auto it = --s.end(), it2 = ----s.end();
                if (it -> first != it2 -> first) {
                    last += it -> se;
                }
                for (int i = p; i + sz <= q; i++) {
                    s.erase(mp(m[a[i]], a[i]));
                    m[a[i]]--;
                    s.emplace(mp(m[a[i]], a[i]));
                    s.erase(mp(m[a[i + sz]], a[i + sz]));
                    m[a[i + sz]]++;
                    s.emplace(mp(m[a[i + sz]], a[i + sz]));
                    it = --s.end(), it2 = ----s.end();
                    if (it -> fi != it2 -> fi) {
                        last += it -> se;
                    }
                }
            }
            cout << last << '\n';
        }
    }
    return 0;
}
