#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef unsigned long long ull;
typedef long double ld;

#define pb emplace_back
#define mp make_pair
#define fi first
#define se second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define EPS 1e-4
#define INF 1e9
#define gcd __gcd

inline void Routine() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

template<class U, class T>
istream &operator >> (istream &in, pair<U, T> &p) {
    in >> p.fi >> p.se;
    return in;
}

template<class U, class T>
ostream &operator << (ostream &out, const pair<U, T> &p) {
    out << p.fi << ' ' << p.se;
    return out;
}

template<class T>
istream &operator >> (istream &in, vector<T> &v) {
    for (auto &c : v) {
        in >> c;
    }
    return in;
}

template<class T>
ostream &operator << (ostream &out, const vector<T> &v) {
    for (auto &c : v) {
        out << c << ' ';
    }
    return out;
}

double distanc(pair<double, double> &a, pair<double, double> &b) {
    return sqrt((a.fi - b.fi) * (a.fi - b.fi) + (a.se - b.se) * (a.se - b.se));
}

signed main() {
    Routine();
    int n, q;
    cin >> n >> q;
    vector<pair<double, double> > a(n);
    cin >> a;
    while (q--) {
        pair<double, double> x;
        cin >> x;
        int ans = 0;
        for (int i = 0; i < n; i++) {
            if (x == a[i]) {
                continue;
            }
            for (int j = i + 1; j < n; j++) {
                if (x == a[j]) {
                    continue;
                }
                double c = distanc(a[i], x), d = distanc(a[i], a[j]), e = distanc(a[j], x);
                if (abs(c - d) < EPS || abs(e - d) < EPS || abs(c - e) < EPS) {
                    ans++;
                }
            }
        }
        cout << ans << '\n';
    }
    return 0;
}
