#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef unsigned long long ull;
typedef long double ld;

#define pb emplace_back
#define mp make_pair
#define fi first
#define se second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define EPS 1e-4
#define INF 1e9
#define gcd __gcd

inline void Routine() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

template<class U, class T>
istream &operator >> (istream &in, pair<U, T> &p) {
    in >> p.fi >> p.se;
    return in;
}

template<class U, class T>
ostream &operator << (ostream &out, const pair<U, T> &p) {
    out << p.fi << ' ' << p.se;
    return out;
}

template<class T>
istream &operator >> (istream &in, vector<T> &v) {
    for (auto &c : v) {
        in >> c;
    }
    return in;
}

template<class T>
ostream &operator << (ostream &out, const vector<T> &v) {
    for (auto &c : v) {
        out << c << ' ';
    }
    return out;
}

double distanc(pair<double, double> &a, pair<double, double> &b) {
    return sqrt((a.fi - b.fi) * (a.fi - b.fi) + (a.se - b.se) * (a.se - b.se));
}

signed main() {
    Routine();
    int n, q;
    cin >> n >> q;
    vector<pair<double, double> > a(n);
    unordered_map<int, vector<pair<double, int> > > dist;
    cin >> a;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            dist[i].pb(distanc(a[i], a[j]), j);
            dist[j].pb(distanc(a[i], a[j]), i);
        }
    }
    for (auto &c : dist) {
        sort(all(c.se));
    }
    while (q--) {
        pair<double, double> x;
        cin >> x;
        int ans = 0;
        set<pair<double, int> > f;
        for (int i = 0; i < n; i++) {
            if (a[i] == x) {
                continue;
            }
            double d = distanc(a[i], x);
            ans += lower_bound(all(dist[i]), mp(d + EPS, 0)) - lower_bound(all(dist[i]), mp(d - EPS, n + 1));
            auto itt = f.lower_bound(mp(d - EPS, n + 1));
            while (itt != f.end() && abs(itt -> fi - d) < EPS) {
                if (abs(distanc(a[i], a[itt -> se]) - distanc(a[i], x)) > EPS) {
                    ans++;
                }
                itt++;
            }
            f.emplace(d, i);
        }
        cout << ans << '\n';
    }/*
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            double x = distanc(a[i], a[j]);
            auto it = dist[i].lower_bound(mp(x - EPS, 0));
            while (it != dist[i].end() && abs(it -> fi - x) <= EPS) {
                if (it -> se == j) {
                    it++;
                    continue;
                }
                ans[i]++;
                ans[j]++;
                ans[it -> se]++;
                it++;
            }
        }
    }
    cout << ans;*/
    return 0;
}
