#include <algorithm>
#include <iostream>
#include <math.h>
//#include <bits/stdc++.h>
using namespace std;

typedef long double ldb;

typedef pair < ldb, ldb > Vec;
#define x first
#define y second


const int N = 1e3 + 5;

Vec lst[N];

ldb eps = 1e-4;

inline ldb dist(Vec a, Vec b) {
    return sqrt((a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y));
}

inline bool equ (ldb a, ldb b) {
    return abs(a - b) < eps;
}

inline ldb f(Vec v) {
    return v.x * v.x + v.y * v.y;
}

int main() {
//#ifdef MY
//    freopen("f.in", "r", stdin);
//#endif // MY
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
//    scanf("%d%d", &n, &m);
    cin >> n >> m;
    for (int i = 0; i < n; i++)
//        scanf("%llf%llf", &lst[i].x, &lst[i].y);
        cin >> lst[i].x >> lst[i].y;
    Vec O;
    for (int i = 0; i < m; i++) {
//        scanf("%llf%llf", &O.x, &O.y);
        cin >> O.x >> O.y;
        int ans = 0;
        for (int j = 0; j < n; j++) {
            for (int t = j + 1; t < n; t++) {
                if (equ(dist(O, lst[j]), dist(O, lst[t])))
                    ans++;
                else if (equ(dist(O, lst[j]), dist(lst[j], lst[t])))
                    ans++;
                else if (equ(dist(O, lst[t]), dist(lst[j], lst[t])))
                    ans++;
            }
        }
//        printf("%d\n", ans);
        cout << ans << '\n';
    }
    //cout << ans;
    return 0;
}
