#include <bits/stdc++.h>
using namespace std;

#define pb push_back
#define F first
#define S second
#define all(v) (v.begin(), v.end())
#define sz(x) int(x.size())
#define print(x) cout << x << endl;
#define print_v(v) for (auto xx : v) cout << xx << ' '; cout << endl;
typedef long long ll;
typedef pair < int, int > pii;
typedef pair < ll, ll > pll;
typedef double db;
typedef long double ldb;

const int mod = 1e9 + 7;
const char sp = ' ';

struct Int {
    ll x;
    Int (ll x = 0) : x(x) {};
    Int operator + (Int a) {
        return (x + a.x) % mod;
    }
    Int operator - (Int a) {
        return (x + mod - a.x) % mod;
    }
    Int operator * (Int a) {
        return (x * a.x) % mod;
    }
};

struct Vec {
    ldb x, y;
    Vec (ldb x = 0, ldb y = 0) : x(x), y(y) {};
    Vec operator - (Vec a) {
        return Vec(x - a.x, y - a.y);
    }
};

//const double eps = 1e-4;

#ifdef MY
    const int N = 1e2;
    const int inf = 1e9;
#else
    const int N = 1e3 + 5;
    const int inf = 1e9;
#endif // MY

Vec lst[N];

ldb eps = 1e-4;

ldb dist(Vec a, Vec b) {
    return sqrt((a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y));
}

bool equ (ldb a, ldb b) {
    return abs(a - b) < eps;
}

ldb f(Vec v) {
    return v.x * v.x + v.y * v.y;
}

int main() {
#ifdef MY
    freopen("f.in", "r", stdin);
#endif // MY
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout << fixed << setprecision(10);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; i++)
        cin >> lst[i].x >> lst[i].y;
    int ans = 0;
    for (int i = 0; i < m; i++) {
        vector < ldb > res;
        Vec O;
        cin >> O.x >> O.y;
        int ans = 0;
        for (int j = 0; j < n; j++) {
            for (int t = j + 1; t < n; t++) {
                if (equ(dist(O, lst[j]), dist(O, lst[t])))
                    ans++;
            }
        }
        cout << ans << endl;
    }
    //cout << ans;
    return 0;
}
