
#include <bits/stdc++.h>

using namespace std;

void speed_up(){
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

void solve();
void solve1();
void solve2();
void solve3();

int main()
{
    speed_up();
    solve();
    return 0;
}

typedef long long ll;
#define F first
#define S second
#define pb push_back
#define all(x) (x).begin(),(x).end()
#define watch(x) cout<<#x<<" : "<<x<<"\n";

double x[1001];
double y[1001];
double rs[1001][1001];

double eps = 0.0001;

bool check(double a,double b){
   // cout<<a<<" "<<b<<" "<<fabs(a-b)<<"\n";
    if(fabs(a - b) < eps){
        return true;
    }
    return false;
}

double dist(double xa,double ya,double xb,double yb){
    return sqrt((xa - xb) * (xa - xb) + (ya - yb) * (ya - yb));
}

void solve(){
    int n;
    int q;
    cin>>n>>q;
    for(int i = 0 ; i < n; i ++){
        cin>>x[i]>>y[i];
    }
    for(int i = 0 ; i < n; i ++){
        for(int j = 0 ; j < n; j ++){
            rs[i][j] = dist(x[i],y[i],x[j],y[j]);
        }
        sort(rs[i],rs[i] + n);
    }
    cerr<<"!";
    for(int i = 0 ; i < q; i++){
        double xx,yy;
        cin>>xx>>yy;
        int ans = 0;
        vector<double>ejis;
       // cout<<"---------------------------\n";
        for(int j = 0 ; j < n ; j ++){
            double ij = dist(xx,yy,x[j],y[j]);
         //   cout<<ij<<"\n";
            ejis.pb(ij);
        }
       // cout<<"---------------------------\n";
        sort(all(ejis));
        for(int j = 0 ; j < n ; j ++){
            double ij = ejis[j];
            int ins = lower_bound(all(ejis),ij - eps) - ejis.begin();
           // cout<<ins<<"*\n";
            while(ins < n && check(ij,ejis[ins])){
                if(ins == j){
                    ins ++;
                }else{
                   // cout<<xx<<" "<<yy<<" "<<x[j]<<" "<<y[j]<<" "<<x[ins]<<" "<<y[ins]<<" "<<ejis[ins]<<" "<<ij<<"!\n";
                    ans++;
                    ins++;
                }
            }
        }
        ans /= 2;
        for(int j = 0 ; j < n ; j ++){
            double ij = dist(xx,yy,x[j],y[j]);
            int ins = lower_bound(rs[j],rs[j] + n,ij - eps) - rs[j];
           // cout<<ins<<"*\n";
            while(ins < n && check(ij,rs[j][ins])){
                    //cout<<xx<<" "<<yy<<" "<<x[j]<<" "<<y[j]<<" "<<x[ins]<<" "<<y[ins]<<" "<<rs[j][ins]<<" "<<ij<<"$\n";
                    ans++;
                    ins++;
            }
        }
        cout<<ans<<"\n";
    }
}

