#include <bits/stdc++.h>

using namespace std;

void solve();

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}

#define int long long

int n, m, last, a[200001];
vector < unordered_map < int, int > > t(400004);

void build(int tl, int tr, int v) {
    if (tl == tr) {
        t[v][a[tl]]++;
    } else {
        int m = (tl + tr) / 2;
        build(tl, m, v * 2);
        build(m + 1, tr, v * 2 + 1);
        t[v] = t[v * 2];
        for (auto it = t[v * 2 + 1].begin(); it != t[v * 2 + 1].end(); it++) {
            t[v][(*it).first] += (*it).second;
        }
    }
}

unordered_map < int, int > get(int l, int r, int tl, int tr, int v) {
    unordered_map < int, int > u;
    if (tl >= l && tr <= r) {
        return t[v];
    }
    if (tl > r || tr < l) {
        return u;
    }
    int m = (tl + tr) / 2;

    u = get(l, r, tl, m, v * 2);
    unordered_map < int, int > pr = get(l, r, m + 1, tr, v * 2 + 1);
    for (auto it = pr.begin(); it != pr.end(); it++) {
        u[(*it).first] += (*it).second;
    }
    return u;
}

void se(int tl, int tr, int v, int pos, int new_val) {
    if (tl == tr) {
        t[v][a[tl]]--;
        t[v][new_val]++;
    } else {
        int m = (tl + tr) / 2;
        if (m <= pos) {
            se(m + 1, tr, v * 2 + 1, pos, new_val);
        } else
            se(tl, m, v * 2, pos, new_val);
        t[v] = t[v * 2];
        for (auto it = t[v * 2 + 1].begin(); it != t[v * 2 + 1].end(); it++) {
            t[v][(*it).first] += (*it).second;
        }
    }

}

void solve() {
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    build(0, n - 1, 1);
    cin >> m;
    for (int i = 0; i < m; i++) {
        int l, r, t;
        cin >> l >> r >> t;
        int type = ((t + last) % 2) + 1;
        if (type == 1) {
            int p = ((l + last) % n) + 1, q = ((r + last) % 100000000) + 1;
            se(0, n - 1, 1, p - 1, q);
            a[p - 1] = q;
        } else {
            int p = ((l + last) % n) + 1, q = ((r + last) % n) + 1;
            unordered_map < int, int > d;
            for (int j = p - 1; j < q; j++) {
                for (int h = j; h < q; h++) {
                    unordered_map < int, int > pr = get(j, h, 0, n - 1, 1);
                    for (auto it = pr.begin(); it != pr.end(); it++) {
                        if ((*it).second > (h - j + 1) / 2) {
                            d[(*it).first]++;
                            break;
                        }
                    }
                }
            }
            int ans = 0;
            for (auto it = d.begin(); it != d.end(); it++) {
                //cout << (*it).first << " " << (*it).second << endl;
                ans += ((*it).first * (*it).second) % 998244353;
                ans %= 998244353;
            }
            last = ans;
            cout << ans << endl;
        }
    }
}


