#include <iostream>
#include <vector>
#include <map>

#pragma GCC optimize("fast-math")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,tune=native")

#define ll long long
#define ld double
#define pb push_back
#define mp make_pair
#define ft first
#define sd second
#define eps 0.0000001
#define mod 998244353

using namespace std;

int main() {

    ios::sync_with_stdio(0);
    cin.tie();
    cout.tie();

    vector <ll> a(300000);

    ll n;
    cin >> n;

    for (ll i = 1; i <= n; i++) {

        cin >> a[i];
    }

    ll m;
    ll lst = 0;

    cin >> m;

    vector <ll> answ;

    for (ll i = 0; i < m; i++) {
        ll l , r , t;

        cin >> l >> r >> t;

        t = (t + lst) % 2 + 1;

        l = (l + lst) % n + 1;
        r = (r + lst) % n + 1;

        if (t == 2) {
            ll ans = 0;
            map <ll,  ll> m;

            for (ll v1 = l; v1 <= r; v1++) {
                for (ll v2 = v1; v2 <= r; v2++) {
                    map <ll , ll> maj;
                    for (ll k = v1; k <= v2; k++) {
                        maj[a[k]]++;
                    }

                    ll mx = -1;
                    ll mxi = -1;
                    for (auto i: maj) {
                        if (i.sd > mx) {
                            mx = i.sd;
                            mxi = i.ft;
                        }
                    }
                    ll kol = 0;
                    for (auto i: maj) {
                        if (i.sd == mx) {
                            kol++;
                        }
                    }

                    ll mj = mxi;

                    if (kol != 1)
                        continue;

                    if (n - mj >= mj)
                        continue;

                    m[mj]++;
                }
            }

            for (auto i: m) {
                ans += ((i.ft * (i.sd % mod)) % mod);
            }
            ans %= mod;
            answ.pb(ans);
            lst = ans;
        }
        else {
            a[l] = r;
        }
    }

    for (auto i: answ) {
        cout << i << '\n';
    }
    return 0;
}
