#include <iostream>
#include <vector>
#include <cmath>

#pragma GCC optimize("fast-math")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,tune=native")

#define ll long long
#define ld double
#define pb push_back
#define mp make_pair
#define ft first
#define sd second
#define eps 0.00001

using namespace std;

int main() {

    ios::sync_with_stdio(0);
    cin.tie();
    cout.tie();

    ld n , q;;

    vector <pair<ld , ld>> a;

    cin >> n >> q;

    for (ll i = 0; i < n; i++) {
        ld x , y;

        cin >> x >> y;

        a.pb(mp(x , y));
    }

    for (ll i = 0; i < q; i++) {
        ld x , y;

        cin >> x >> y;
        ll ans = 0;

        for (ll j = 0; j < q; j++) {
            ll r1 = abs(x - a[j].ft) * abs(x - a[j].ft) + abs(y - a[j].sd) * abs(y - a[j].sd);

            if (r1 < eps)
                continue;
            for (ll k = j + 1; k < n; k++) {
                ll r2 = abs(x - a[k].ft) * abs(x - a[k].ft) + abs(y - a[k].sd) * abs(y - a[k].sd);
                ll r3 = abs(a[j].ft - a[k].ft) * abs(a[j].ft - a[k].ft) + abs(a[j].sd - a[k].sd) * abs(a[j].sd - a[k].sd);
                if (r2 < eps || r3 < eps)
                    continue;

                if (abs(r1 - r2) < eps || abs(r3 - r2) < eps || abs(r1 - r3) < eps) {
                    ans++;
                }
            }
        }

        cout << ans << '/n';
    }
    return 0;
}
