#include <bits/stdc++.h>
using namespace std;

typedef long double ld;
typedef long long ll;
#define fr first
#define sc second
#define mpr mkae_pair

const int N=1006;
vector<ld> dist[N],v[N];
struct point{
	ld x,y;
} ps[N];

ld get_dist(point a,point b){
	return sqrtl((a.x-b.x)*(a.x-b.x)+(a.y-b.y)*(a.y-b.y));
}

int main(){
	ios_base::sync_with_stdio(false);
	//freopen("inp.txt","r",stdin);
	int n,q;
	cin>>n>>q;
	for (int i=0;i<n;i++){
		cin>>ps[i].x>>ps[i].y;
	}
	for (int i=0;i<n;i++){
		dist[i].resize(n-1);
		for (int j=0;j<n;j++){
			if (j==i)continue;
			dist[i][j]=get_dist(ps[i],ps[j]);
		}
		sort(dist[i].begin(),dist[i].end());
	}
	for (int i=0;i<q;i++){
		point tv;
		cin>>tv.x>>tv.y;
		//cout<<tv.x<<" "<<tv.y<<endl;
		for (int j=0;j<n;j++){
			v[i].push_back(get_dist(tv,ps[j]));
		}
		sort(v[i].begin(),v[i].end());
		int ans=0;
		for (int j=0;j<n;j++){
			int l=upper_bound(v[i].begin(),v[i].end(),v[i][j]-(ld)(0.0001))-v[i].begin();
			int r=lower_bound(v[i].begin(),v[i].end(),v[i][j]+(ld)(0.0001))-v[i].begin()-1;
			ans+=r-l;
			//cout<<j<<endl;
		}
		ans/=2;
		for (int j=0;j<n;j++){
			//cout<<"hi "<<j<<endl;
			int l=upper_bound(dist[j].begin(),dist[j].end(),v[i][j]-(ld)(0.0001))-dist[j].begin();
			int r=lower_bound(dist[j].begin(),dist[j].end(),v[i][j]+(ld)(0.0001))-dist[j].begin()-1;
			ans+=r-l+1;
		}
		cout<<ans<<endl;
	}
	return 0;
}
//Cybm4dBm
/*
4 3 -std=c++11
  0.0 5.0
  3.0 4.0
  4.0 3.0
  5.0 0.0
  5.0 5.0
  0.0 0.0
  0.0 9.0 */
