#include <iostream>
#include <algorithm>
#include <vector>
#include <queue>
#include <cmath>
#include <set>
#include <map>
using namespace std;
typedef  double LD;
const  double EPS=0.0001;
const int MAXN=1005;

 double x[MAXN], y[MAXN];
 double dist[MAXN][MAXN];
 double P[MAXN];

int per(int n, LD Px, LD Py);
inline LD D(LD x, LD y, LD X, LD Y);
int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	int Q, n, l, r, l_ind, r_ind;
	 double Px, Py, R;
	 double * it;
	cin>>n>>Q;
	for (int i=0; i<n; i++)
	{
		cin>>x[i]>>y[i];
		//dist[i].resize(n);
	}
	//init dist[0...n-1]...
	for (int i=0; i<n; i++)
	{
		for (int j=i+1; j<n; j++)
			dist[i][j]=dist[j][i]=D(x[i], y[i], x[j], y[j]);
	}
	for (int i=0; i<n; i++)
	{
		dist[i][i]=10000000.;
		sort(dist[i], dist[i]+n);
	}
	//~0.01
	while (Q--)
	{
		int ans=0;
		cin>>Px>>Py;
		//init P...
		for (int i=0; i<n; i++)
			P[i]=D(Px, Py, x[i], y[i]);
		sort(P, P+n);
		//1in tesak: P-n gagatn e
		//saxoh patuhan, p[l...r] bolor zuygeri tarberutyan moduly < EPS
		l=0, r=0;
		while (l<n)
		{
			while (r+1<n && P[r+1]-P[l]<EPS)
				r++; //binsearch? ChOGNEC
			/*
			int ll=r, rr=n-1;
			while (ll+1<rr)
			{
				int m=(ll+rr)>>1;
				if (P[m]-P[l]<EPS)
					ll=m;
				else
					rr=m-1;
			}
			if (P[rr]-P[l]<EPS)
				r=rr;
			else
				r=ll;
			*/
			ans+=r-l; // (l, l+1), (l, l+2), (l, l+3), ..., (l, r) zuygry
			l++;
			//if (r<l) // Es petqa???
				//r=l;
		}
		//cerr<<"P-n gagtn e, ans = "<<ans<<'\n';;
		//2rd tesak: mi voreve (x[i]; y[i])-n e gagaty
		for (int i=0; i<n; i++)
		{ // (x[i]; y[i])-n e gagaty
			// hashvenq l, r aynpes vor (dist[i][l...r]-R) < EPS,
			// vortex R = D(P, i)
			R=D(Px, Py, x[i], y[i]);
			it=upper_bound(dist[i], dist[i]+n-1, R-EPS);
            if (it==dist[i]+n)
				continue;
			l_ind=it-dist[i];
			it=lower_bound(dist[i], dist[i]+n-1, R+EPS);
			r_ind=it-dist[i]-1;
			if (l_ind<=r_ind)
				ans+=r_ind-l_ind+1;
		}
		//
		/*
		if (ans==per(n, Px, Py))
			cerr<<"OK ";
		else
			cerr<<"WA ans = "<<per(n, Px, Py)<<'\n';
		*/
		cout<<ans<<'\n';
	}
	return 0;
}

inline LD D(LD x, LD y, LD X, LD Y)
{
	return sqrt((X-x)*(X-x)+(Y-y)*(Y-y));
}


/*int per(int n, LD Px, LD Py)
{
	int ret=0;
	for (int i=0; i<n; i++)
	{
		for (int j=i+1; j<n; j++)
		{
			 double dst[3]={D(Px, Py, x[i], y[i]),
			D(Px, Py, x[j], y[j]), D(x[i], y[i], x[j], y[j])};
			if (abs(dst[0]-dst[1])<EPS || abs(dst[1]-dst[2])<EPS
				|| abs(dst[0]-dst[2])<EPS)
					ret++;
		}
	}
	return ret;
}

4 1000
0 0
0 1
1 0
1 1

0 0
*/
