#include <bits/stdc++.h>
#define endl '\n'
#define MAXN 200003
#define MOD 998244353
#define MAXNUM 100000000
using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
int n;
int arr[MAXN];
int m;
void read()
{
    cin >> n;
    for (int i = 1; i <= n; i++)
        cin >> arr[i];
    cin >> m;
}
int last_output = 0;
ll add(ll a, ll b)
{
    a += b;
    if (a >= MOD)
        a -= MOD;
    else if (a < 0)
        a += MOD;
    return a;
}
ll mult(ll a, ll b)
{
    a = a * b % MOD;
    if (a < 0)
        a += MOD;
    return a;
}
void solve()
{
    for (int i = 1; i <= m; i++)
    {
        int l, r, t;
        cin >> l >> r >> t;
        t = (t + last_output) % 2 + 1;
        if (t == 1)
        {
            l = (l + last_output) % n + 1;
            r = (r + last_output) % MAXNUM + 1;
            arr[l] = r;
        }
        else
        {
            l = (l + last_output) % n + 1;
            r = (r + last_output) % n + 1;
            ll ans = 0;
            for (int i = l; i <= r; i++)
            {
                unordered_map <int, int> cnt;
                int idx = 0;
                for (int j = i; j <= r; j++)
                {
                    cnt[arr[j]]++;
                    if (cnt[arr[j]] > cnt[idx])
                    idx = arr[j];
                    if (2*cnt[idx] > j-i+1)
                    ans = add(ans, idx);
                }
            }
            last_output = ans;
            cout << ans << endl;
        }

    }
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    read();
    solve();
}

