#include <bits/stdc++.h>
#define endl '\n'
#define MAXN 1024
#define EPS 0.0001
using namespace std;
int n, q;
pair <double, double> arr[MAXN];
void read()
{
    cin >> n >> q;
    for (int i = 1; i <= n; i++)
        cin >> arr[i].first >> arr[i].second;
}
bool cmp1(pair <double, double> a, pair <double, double> b)
{
    return a.first < b.first;
}
bool cmp2(pair <double, double> a, pair <double, double> b)
{
    return a.second < b.second;
}
vector <pair <double, double> > tr[MAXN*4];
void build(int v, bool is)
{
    if (tr[v].size() == 1)
        return;
    if (!is)
        sort(tr[v].begin(), tr[v].end(), cmp1);
    else
        sort(tr[v].begin(), tr[v].end(), cmp2);
    int mid = tr[v].size() >> 1;
    for (int i = 0; i < mid; i++)
        tr[v << 1].push_back(tr[v][i]);
    for (int i = mid; i < tr[v].size(); i++)
        tr[(v << 1) + 1].push_back(tr[v][i]);
    build(v << 1, is ^ 1);
    build((v << 1) + 1, is ^ 1);
}
double dist(pair <double, double> a, pair <double, double> b)
{
    return sqrt((a.first - b.first) * (a.first - b.first) + (a.second - b.second) * (a.second - b.second));
}
int ans;
void get(int v, pair <double, double> pt, double range, bool is)
{
    if (tr[v].size() == 1)
    {
        if (fabs(dist(pt, tr[v][0]) - range) < EPS)
            ans++;
        return;
    }
    get(v << 1, pt, range, is ^ 1);
    get((v << 1) + 1, pt, range, is ^ 1);
}
void solve()
{
    for (int i = 1; i <= n; i++)
    tr[1].push_back(arr[i]);
    build(1, false);
    for (int i = 1; i <= q; i++)
    {
        pair <double, double> x;
        cin >> x.first >> x.second;
        int big_ans = 0;
        for (int i = 1; i <= n; i++)
        {
            ans = 0;
            double curr_dist = dist(x, arr[i]);
            get(1, x, curr_dist, false);
            big_ans += ans - 1;
        }
        big_ans >>= 1;
        cout << big_ans << endl;
    }
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    read();
    solve();
}
