#include<iostream>
#include<algorithm>
#include<queue>
#include<cmath>
using namespace std;
struct point{
    double x,y;
};
point pts[10000];
double dists[10000];
double all[1000000];
double eps=0.0003;
bool cmp(double a,double b){
    if(a+0.000000001<b){
        return 0;
    }
    return 1;
}
int main(){
    std::cin.tie(nullptr);
    std::ios::sync_with_stdio(false);
    int n,m;
    cin>>n>>m;
    for(int i=0;i<n;i++){
        cin>>pts[i].x>>pts[i].y;
    }
    int allsiz=0;
    for(int i=0;i<n;i++){
        for(int j=i+1;j<n;j++){
            all[allsiz++]=sqrt((pts[i].x-pts[j].x)*(pts[i].x-pts[j].x)+(pts[i].y-pts[j].y)*(pts[i].y-pts[j].y));
        }
    }
    sort(all,all+allsiz);
    /*for(int i=0;i<allsiz;i++){
        cout<<all[i]<<" ";
    }
    cout<<endl;*/
    for(int i=0;i<m;i++){
        point curr;
        cin>>curr.x>>curr.y;
        for(int j=0;j<n;j++){
            dists[j]=sqrt((curr.x-pts[j].x)*(curr.x-pts[j].x)+(curr.y-pts[j].y)*(curr.y-pts[j].y));
        }
        sort(dists,dists+n);
        long long ans=0;
        queue<double>lens;
        for(int j=0;j<n;j++){
            double a=dists[j];
            while(!lens.empty() && lens.front()+eps<a){
                lens.pop();
            }
            ans+=lens.size();
            lens.push(a);
        }
        /*for(int j=0;j<n;j++){
            cout<<dists
        }*/
        while(!lens.empty())lens.pop();
        int to=0;
        for(int j=0;j<n;j++){
            double a=dists[j];
            while(!lens.empty() && lens.front()+eps<a){
                lens.pop();
            }
            for(;to<allsiz;to++){
                if(all[to]+eps>a && all[to]-eps<a){
                    lens.push(all[to]);
                }else if(all[to]+eps>a){
                    break;
                }
            }
            ans+=lens.size();
        }
        cout<<ans<<"\n";
    }
    return 0;
}
