#include<iostream>
#include<algorithm>
#include<queue>
#include<cmath>
using namespace std;
struct point
{
    double x,y;
};
point pts[10000];
double dists[10000];
double all[1000000];
double eps=0.0001;
bool cmp(double a,double b)
{
    if(a+0.000000001<b)
    {
        return 1;
    }
    return 0;
}
int main()
{
    std::cin.tie(nullptr);
    std::ios::sync_with_stdio(false);
    int n,m;
    cin>>n>>m;
    for(int i=0; i<n; i++)
    {
        cin>>pts[i].x>>pts[i].y;
    }
    int allsiz=0;
    for(int i=0; i<n; i++)
    {
        for(int j=i+1; j<n; j++)
        {
            all[allsiz++]=sqrt((pts[i].x-pts[j].x)*(pts[i].x-pts[j].x)+(pts[i].y-pts[j].y)*(pts[i].y-pts[j].y));
        }
    }
    sort(all,all+allsiz,cmp);
    for(int i=0; i<m; i++)
    {
        point curr;
        cin>>curr.x>>curr.y;
        long long ans=0;

        for(int j=0; j<n; j++)
        {
            dists[j]=sqrt((curr.x-pts[j].x)*(curr.x-pts[j].x)+(curr.y-pts[j].y)*(curr.y-pts[j].y));
        }
        sort(dists,dists+n,cmp);
        queue<double>lens;
        for(int j=0; j<n; j++)
        {
            double a=dists[j];
            while(!lens.empty() && lens.front()+eps<a)
            {
                lens.pop();
            }
            ans+=lens.size();
            lens.push(a);
        }
        cout<<ans<<endl;
    }
    return 0;
}
