#include<bits/stdc++.h>

using namespace std;

const long long big_number = 1e8;
const long long mod = 998244353;
const long long MAXN = 2e5 + 7;

long long a[MAXN];
long long cnt[big_number];

long long solve(long long l, long long r)
{
    long long res = 0;

    for(long long i = l; i <= r; ++i)
    {
        long long maxi = 0, val = -1;

        for(long long j = i; j <= r; ++j)
        {
            cnt[a[j]]++;

            if(cnt[a[j]] > maxi)
            {
                maxi = cnt[a[j]];
                val = a[j];
            }

            if((maxi<<1) > (j-i+1))
            {
                res += val;
                while(res >= mod)
                    res -= mod;
            }

            if(((maxi+r-j)<<1) <= (r-i))
                break;
        }

        for(long long j = i; j <= r; ++j)
            cnt[a[j]]--;
    }

    return res;
}

int main ()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    long long n, m;

    cin >> n;

    for(long long i = 1; i <= n; ++i)
        cin >> a[i];

    cin >> m;

    long long last_output = 0;

    for(long long i = 0; i < m; ++i)
    {
        long long l, r, t;

        cin >> l >> r >> t;

        long long type = ((t+last_output)%2)+1;
        long long p, q;

        if(type == 1)
        {
            p = ((l+last_output)%n)+1;
            q = ((r+last_output)%big_number)+1;
        }
        else
        {
            p = ((l+last_output)%n)+1;
            q = ((r+last_output)%n)+1;
        }

        if(type == 1)
        {
            a[p] = q;
        }
        else
        {
            long long res = solve(p, q);

            cout << res << "\n";

            last_output = res;
        }
    }

    return 0;
}
