#include<bits/stdc++.h>

using namespace std;

const int MAXN = 1007;
const long double eps = 0.0001;

pair<long double, long double> p[MAXN];
long double d[MAXN];

long double dist(pair<long double, long double> a, pair<long double, long double> b)
{
    return (long double)sqrt((a.first - b.first)*(a.first - b.first) + (a.second - b.second)*(a.second  - b.second));
}

bool ok(long double a, long double b)
{
    if(fabs(a - b) < eps)
        return 1;

    return 0;
}

int main ()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    int n, q;

    cin >> n >> q;

    for(int i = 0; i < n; i++)
        cin >> p[i].first >> p[i].second;

    for(int i = 0; i < q; i++)
    {
        pair<long double, long double> x;

        cin >> x.first >> x.second;

        for(long long j = 0; j < n; j++)
            d[j] = dist(x, p[j]);

        sort(d, d+n);

        long long j = 0, res = 0;

        for(long long k = 0; k < n; k++)
        {
            while(!ok(d[k], d[j]))
                j++;

            res += k-j;
        }

        cout << res << "\n";
    }

    return 0;
}
