#include <bits/stdc++.h>
#define endl '\n'
#define MAXN 1001
using namespace std;
int n, q;

struct point
{
    long double x, y;
};

long double getDist(point a, point b)
{
    return sqrt((a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y));
}

point pts[MAXN];
long double dist[MAXN][MAXN];

void input()
{
    cin >> n >> q;

    for (int i = 0; i < n; i++)
        cin >> pts[i].x >> pts[i].y;
}

void init()
{
    for (int i = 0; i < n; i++)
        for (int j = i + 1; j < n; j++)
            dist[i][j] = dist[j][i] = getDist(pts[i], pts[j]);
}

int check(point c)
{
    int cnt = 0;

    for (int i = 0; i < n; i++)
        for (int j = i + 1; j < n; j++)
        {
            point a = pts[i];
            point b = pts[j];
            long double ab = dist[i][j];
            long double ac = getDist(a, c);
            long double bc = getDist(b, c);

            if (ac == bc && fabs(bc - ac) < 0.0001) cnt++;
        }

    return cnt;
}

void solve()
{
    for (int i = 0; i < q; i++)
    {
        point curr;
        cin >> curr.x >> curr.y;
        cout << check(curr) << endl;
    }
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    input();
    init();
    solve();

    return 0;
}
