#include <bits/stdc++.h>
#define endl '\n'
#define TRACE(x) cerr << #x << " = " << x << endl

using namespace std;
template<class T, class T1> inline bool chkmax(T &x, const T1 &y) { return x < y ? x = y, true : false; }
template<class T, class T1> inline bool chkmin(T &x, const T1 &y) { return x > y ? x = y, true : false; }

const int MAXN = 200001;
const int MOD = 998244353;

struct Element {
    int val;
    int cnt;

    Element(int val, int cnt) {
        this->val = val;
        this->cnt = cnt;
    }

    bool operator <(const Element &other) const {
        return this->cnt < other.cnt;
    }
};

int n;
int m;

void read() {
}

int a[MAXN];
map<int, int> cnt;
map<int, int> cnt2;

int query(int l, int r) {
    cnt.clear();
    for (int i = l; i <= r; i++) {
        cnt2.clear();
        for (int j = i; j <= r; j++) {
            cnt2[a[j]]++;
            int len = j - i + 1;
            int val;
            int o = 0;
            for (auto &it : cnt2) {
                if (it.second > len - it.second) {
                    val = it.first;
                    o++;
                }
            }
            if (!o || o > 1) continue;
            cnt[val]++;
        }
    }
    int ans = 0;
    for (auto &it : cnt) ans += it.first * it.second;
    return ans;
}

void solve() {
    cin >> n;
    for (int i = 1; i <= n; i++) cin >> a[i];
    int lastOutput = 0;
    cin >> m;
    for (int i = 1; i <= m; i++) {
        int l, r, t;
        cin >> l >> r >> t;
        int type = ((t + lastOutput) & 1) + 1;
        if (type == 1) {
            int p = ((l + lastOutput) % n) + 1;
            int q = ((r + lastOutput) % 100000000) + 1;
            a[p] = q;
        }
        else {
            int p = ((l + lastOutput) % n) + 1;
            int q = ((r + lastOutput) % n) + 1;
            lastOutput = query(p, q);
            cout << lastOutput << endl;
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();

    return EXIT_SUCCESS;
}

