#include <bits/stdc++.h>
#define endl '\n'
#define TRACE(x) cerr << #x << " = " << x << endl

using namespace std;
template<class T, class T1> inline bool chkmax(T &x, const T1 &y) { return x < y ? x = y, true : false; }
template<class T, class T1> inline bool chkmin(T &x, const T1 &y) { return x > y ? x = y, true : false; }

const int MAXN = 200001;
const int MOD = 998244353;

struct Element {
    int val;
    int cnt;

    Element(int val, int cnt) {
        this->val = val;
        this->cnt = cnt;
    }

    bool operator <(const Element &other) const {
        return this->cnt < other.cnt;
    }
};

int n;
int m;

void read() {
}

int a[MAXN];
map<int, int> cnt;
pair<int, int> tree[2048];

pair<int, int> combineData(pair<int, int> a, pair<int, int> b) {
    if (a.first == b.first) return {a.first, a.second + b.second};
    if (a.second == b.second) return {max(a.first, b.first), b.second};
    if (a.second > b.second) return a;
    return b;
}

void build(int idx, int low, int high) {
    if (low == high) tree[idx] = {a[low], 1};
    int mid = (low + high) >> 1;
    build(idx << 1, low, mid);
    build(idx << 1 | 1, mid + 1, high);
    tree[idx] = combineData(tree[idx << 1], tree[idx << 1 | 1]);
}

pair<int, int> query(int idx, int low, int high, int l, int r) {
    if (low >= l && high <= r) return tree[idx];
    if (high < l || low > r) return {0, -1};
    int mid = (low + high) >> 1;
    return combineData(query(idx << 1, low, mid, l, r), query(idx << 1 | 1, mid + 1, high, l, r));
}

int query(int l, int r) {
    cnt.clear();
    for (int i = l; i <= r; i++) {
        for (int j = i; j <= r; j++) {
            pair<int, int> curr = query(1, 1, n, i, j);
            int len = j - i + 1;
            if (curr.second > len - curr.second) {
                cnt[curr.first]++;
                if (cnt[curr.first] >= MOD) cnt[curr.first] -= MOD;
            }
        }
    }
    int ans = 0;
    for (auto &it : cnt) ans = (ans + ((long long)it.first * it.second) % MOD) % MOD;
    return ans;
}

void solve() {
    cin >> n;
    for (int i = 1; i <= n; i++) cin >> a[i];
    build(1, 1, n);
    int lastOutput = 0;
    cin >> m;
    for (int i = 1; i <= m; i++) {
        int l, r, t;
        cin >> l >> r >> t;
        int type = ((t + lastOutput) & 1) + 1;
        if (type == 1) {
            int p = ((l + lastOutput) % n) + 1;
            int q = ((r + lastOutput) % 100000000) + 1;
            a[p] = q;
        }
        else {
            int p = ((l + lastOutput) % n) + 1;
            int q = ((r + lastOutput) % n) + 1;
            lastOutput = query(p, q);
            cout << lastOutput << endl;
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();

    return EXIT_SUCCESS;
}

