#include <bits/stdc++.h>
#define endl '\n'
#define TRACE(x) cerr << #x << " = " << x << endl

using namespace std;
template<class T, class T1> inline bool chkmax(T &x, const T1 &y) { return x < y ? x = y, true : false; }
template<class T, class T1> inline bool chkmin(T &x, const T1 &y) { return x > y ? x = y, true : false; }

const double EPS = 0.0001;
const int MAXN = 1000;

struct Point {
    double x;
    double y;

    void read() {
        double x, y;
        cin >> x >> y;
        this->x = x;
        this->y = y;
    }
};

ostream& operator <<(ostream &os, const Point &p) {
    return os << '(' << p.x << ", " << p.y << ')';
}

int n, q;
Point a[MAXN];

void read() {
    cin >> n >> q;
    for (int i = 0; i < n; i++) a[i].read();
}

double getLength(Point a, Point b) {
    double x = fabs(a.x - b.x);
    double y = fabs(a.y - b.y);
    return sqrt(x * x + y * y);
}

void solve() {
    Point curr;
    for (int i = 0; i < q; i++) {
        int ans = 0;
        curr.read(); ///a
        for (int j = 0; j < n; j++) { ///b
            for (int k = j + 1; k < n; k++) { ///c
                double l1 = getLength(curr, a[j]);
                double l2 = getLength(curr, a[k]);
                double l3 = getLength(a[j], a[k]);
                double diff1 = fabs(l1 - l2);
                double diff2 = fabs(l1 - l3);
                double diff3 = fabs(l2 - l3);
                if (diff1 < EPS || diff2 < EPS || diff3 < EPS) ans++;
            }
        }
        cout << ans << endl;
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout.precision(1);
    cout.setf(ios::fixed);

    read();
    solve();

    return EXIT_SUCCESS;
}

