#include<bits/stdc++.h>
using namespace std;
//const float err = 0.00003;
float x[1024],y[1024]; int n;
float dist(float x1,float y1,float x2,float y2)
{
    return sqrt((x1-x2)*(x1-x2)+(y1-y2)*(y1-y2));
}
float d[1024][1024];
float dd[1024];
int bs1(int ind,float a)
{
    int l=0,r=n-1,mid,ans=-1;
    while(l<=r)
    {
        mid=(l+r)>>1;
        if(fabs(d[ind][mid]-a)<0.000015)
        {
            ans=mid; r=mid-1;
        }
        else if(d[ind][mid]>a) r=mid-1;
        else l=mid+1;
    }
    return ans;
}
int bs2(int ind,float a)
{
    int l=0,r=n-1,mid,ans=-1;
    while(l<=r)
    {
        mid=(l+r)>>1;
        if(fabs(d[ind][mid]-a)<0.000015)
        {
            ans=mid; l=mid+1;
        }
        else if(d[ind][mid]>a) r=mid-1;
        else l=mid+1;
    }
    return ans;
}
int bs3(float a)
{
    int l=0,r=n-1,mid,ans=-1;
    while(l<=r)
    {
        mid=(l+r)>>1;
        if(fabs(dd[mid]-a)<0.000015)
        {
            ans=mid; r=mid-1;
        }
        else if(dd[mid]>a)
        {
            r=mid-1;
        }else l=mid+1;
    }
    return ans;
}
int bs4(float a)
{
    int l=0,r=n-1,mid,ans=-1;
    while(l<=r)
    {
        mid=(l+r)>>1;
        if(fabs(dd[mid]-a)<0.000015)
        {
            ans=mid; l=mid+1;
        }
        else if(dd[mid]>a)
        {
            r=mid-1;
        }else l=mid+1;
    }
    return ans;
}
int query(float a,float b)
{
    int br=0,br1=0;
    for(int i=0;i<n;i++)
    {
        dd[i]=dist(x[i],y[i],a,b);
    }
    sort(dd,dd+n);
    //for(int i=0;i<n;i++) cout<<dd[i]<<" "; cout<<endl;
    for(int i=0;i<n;i++)
    {
        float d1=dist(x[i],y[i],a,b);
        int ind1=bs1(i,d1);
        int ind2=bs2(i,d1);
        //cout<<i<<" "<<d1<<" "<<ind1<<" "<<ind2<<endl;
        if(ind1>-1)
        {
            br+=ind2-ind1+1;
        }
        ind1=bs3(d1);
        ind2=bs4(d1);
        //cout<<i<<" "<<d1<<" "<<ind1<<" "<<ind2<<endl;
        br1+=ind2-ind1;
    }
    return br+(br1>>1);
}
int main()
{
    ios_base::sync_with_stdio(0);
    int m;
    cin>>n>>m;
    for(int i=0;i<n;i++)
    {
        cin>>x[i]>>y[i];
    }
    for(int i=0;i<n;i++)
    {
        for(int j=i+1;j<n;j++)
        {
            d[i][j]=dist(x[i],y[i],x[j],y[j]);
        }
        sort(d[i],d[i]+n);
    }
    for(int i=0;i<m;i++)
    {
        float a,b;
        cin>>a>>b;
        cout<<query(a,b)<<endl;
    }
    return 0;
}
/*

4 3
0.0 5.0
3.0 4.0
4.0 3.0
5.0 0.0
5.0 5.0
0.0 0.0
0.0 9.0

6 3
1 2
1.2 4
2.5 0.5
3 3
5 1
1 0
1 1
3.5 4
1.69 2

*/
