#include <iostream>
#include <cmath>
using namespace std;

int n;
int q;
const int MAXN = 1024;
struct Point {
    float x, y;
};
Point pS[MAXN];
const float DIFF =  0.0001;

float calcLength(int x1, int y1, int x2, int y2) {
    float side1 = abs(x1 - x2);
    float side2 = abs(y1 - y2);
    return sqrt( ( side1 * side1 ) + (side2 * side2) );
}

int main() {
    cin >> n >> q;
    for(int i = 0;i < n; ++i)
        cin >> pS[i].x >> pS[i].y;
    for(int i = 0;i < q; ++i) {
        float qX, qY;
        cin >> qX >> qY;
        int ans = 0;
        for(int p1 = 0;p1 < n; ++p1) {
            for(int p2 = p1 + 1;p2 < n; ++p2) {
                float side1 = calcLength(qX, qY, pS[p1].x, pS[p1].y);
                float side2 = calcLength(qX, qY, pS[p2].x, pS[p2].y);
                if(abs(side1 - side2) < DIFF) {
                    ++ans;
                    //cout << "(" << qX << "," << qY << "),(" << pS[p1].x << "," << pS[p1].y << "),(" << pS[p2].x << "," << pS[p2].y << ")" <<endl;
                    continue;
                }
                float side3 = calcLength(pS[p1].x, pS[p1].y, pS[p2].x, pS[p2].y);
                if(abs(side2 - side3) < DIFF || abs(side3 - side1) < DIFF) {
                    //cout << "(" << qX << "," << qY << "),(" << pS[p1].x << "," << pS[p1].y << "),(" << pS[p2].x << "," << pS[p2].y << ")" <<endl;
                    ++ans;
                }
            }
        }
        cout << ans << endl;
    }
    return 0;
}
