#include <iostream>
#include <cmath>
using namespace std;

int n;
int q;
const int MAXN = 1024;
struct Point {
    double x, y;
};
Point pS[MAXN];
const double DIFF = 0.00003;///0.0001999999999
int ans[MAXN];

double calcLength(int x1, int y1, int x2, int y2) {
    double side1 = abs(x1 - x2);
    double side2 = abs(y1 - y2);
    //return sqrt( ( side1 * side1 ) + (side2 * side2) );
    return hypot(side1, side2);
}

int main() {
    cin >> n >> q;
    for(int i = 0;i < n; ++i)
        cin >> pS[i].x >> pS[i].y;
    for(int i = 0;i < q; ++i) {
        double qX, qY;
        cin >> qX >> qY;
        for(int p1 = 0;p1 < n; ++p1) {
            for(int p2 = p1 + 1;p2 < n; ++p2) {
                double side1 = calcLength(qX, qY, pS[p1].x, pS[p1].y);
                double side2 = calcLength(qX, qY, pS[p2].x, pS[p2].y);
                if(abs(side1 - side2) < DIFF) {
                    ++ans[i];
                    //cout << "(" << qX << "," << qY << "),(" << pS[p1].x << "," << pS[p1].y << "),(" << pS[p2].x << "," << pS[p2].y << ")" <<endl;
                    continue;
                }
                double side3 = calcLength(pS[p1].x, pS[p1].y, pS[p2].x, pS[p2].y);
                if(abs(side2 - side3) < DIFF || abs(side3 - side1) < DIFF) {
                    //cout << "(" << qX << "," << qY << "),(" << pS[p1].x << "," << pS[p1].y << "),(" << pS[p2].x << "," << pS[p2].y << ")" <<endl;
                    ++ans[i];
                }
            }
        }
        //cout << ans << endl;
    }
    for(int i = 0;i < q; ++i)
        cout << ans[i] << endl;
    return 0;
}
