#include<bits/stdc++.h>
#define endl '\n'
using namespace std;

int n, q;
vector< pair<double, double> > dots, dotsQ;
double D[1024][1024], DQ[1024][1024];

double getDistance(double x1, double y1, double x2, double y2)
{
    double a=abs(x1-x2), b=abs(y1-y2);
    double c=a*a+b*b;
    double dist=sqrt(c);

    return dist;
}

double solve(int dot)
{
    double answer=0;

    for(int i=0; i<n; ++i)
    {
        double d1x=dots[i].first, d1y=dots[i].second;
        double r1=DQ[i][dot];

        for(int j=i+1; j<n; ++j)
        {
            double d2x=dots[j].first, d2y=dots[j].second;
            double r2=DQ[j][dot];
            double r3=D[i][j];
            //cout<<r1<<" "<<r2<<" "<<r3<<endl;

            if(abs(r1-r2)<0.0001 || abs(r1-r3)<0.0001 || abs(r2-r3)<0.0001)
                answer++;
        }
    }

    return answer;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin>>n>>q;

    double x, y;
    for(int i=0; i<n; ++i)
    {
        cin>>x>>y;
        dots.push_back(make_pair(x, y));
    }
    for(int i=0; i<q; ++i)
    {
        cin>>x>>y;
        dotsQ.push_back(make_pair(x, y));
    }

    for(int i=0; i<n; ++i)
        for(int j=i+1; j<n; ++j)
            D[i][j]=getDistance(dots[i].first, dots[i].second,
                                dots[j].first, dots[j].second);

    for(int i=0; i<n; ++i)
        for(int j=0; j<q; ++j)
            DQ[i][j]=getDistance(dots[i].first, dots[i].second,
                                dotsQ[j].first, dotsQ[j].second);

    for(int i=0; i<q; ++i)
    {
        double answer=solve(i);
        cout<<answer<<endl;
        answer=0;
    }

    return 0;
}
/*
4 3
0.0 5.0
3.0 4.0
4.0 3.0
5.0 0.0
5.0 5.0
0.0 0.0
0.0 9.0
*/
