#include <cstdio>

#define MAXN 200000
#define INF 100000000

using namespace std;

int v[MAXN+5], f[MAXN+5];

int query( int st, int dr )
{
  long long ans=0;

  for( int p=st;p<=dr;p++ )
  {
    int s=0;

    for( int i=st;i<=dr;i++ )
    {
      f[i-st+1]=(v[i]==v[p]);
      f[i-st+1]+=f[i-st];
    }

    for( int i=st;i<=dr;i++ )
      for( int j=i;j<=dr;j++ )
        if( 2*(f[j-st+1]-f[i-st])>j-i+1 )
          s++;

    ans+=1LL*s*v[p];
  }

  return ans;
}


int main()
{
  int n, m, k;

  scanf( "%d", &n );

  for( int i=1;i<=n;i++ )
    scanf( "%d", &v[i] );

  scanf( "%d", &m );

  long long lo=0;

  while( m )
  {
    int l, r, t;

    scanf( "%d%d%d", &l, &r, &t );

    t=(t+lo)%2+1;

    if( t==1 )
    {
      l=(l+lo)%n+1;
      r=(r+lo)%INF+1;

      v[l]=r;
    }
    else
    {
      l=(l+lo)%n+1;
      r=(r+lo)%n+1;

      lo=query(l,r);

      printf( "%d", lo );
    }

    m--;
  }

  return 0;
}
