#include <bits/stdc++.h>

using namespace std;

const double EPSILON = 0.0001 * 0.0001;

const int MAXN = 1000;

unordered_map <double, int> mp;

vector <double> dist[MAXN + 1];

int caut (double val, int a) {
  int bound1, bound2, st, dr, mij;
  bound1 = -1;
  st = 0;
  dr = dist[a].size () - 1;
  while (st <= dr) {
    mij = (st + dr) / 2;
    if (dist[a][mij] - val <= EPSILON) {
      st = mij + 1;
      if (val - dist[a][mij] < EPSILON && val - dist[a][mij] > - EPSILON)
        bound1 = mij;
    }
    else {
      dr = mij - 1;
    }
  }

  bound2 = -1;
  st = 0;
  dr = dist[a].size () - 1;
  while (st <= dr) {
    mij = (st + dr) / 2;
    if (dist[a][mij] - val >= -EPSILON) {
      dr = mij - 1;
      if (val - dist[a][mij] < EPSILON && val - dist[a][mij] > - EPSILON)
        bound1 = mij;
    }
    else {
      st = mij + 1;
    }
  }
  if (bound1 == -1 || bound2 == -1)
    return 0;
  return bound1 - bound2 + 1;
}

double x[MAXN + 1], y[MAXN + 1];


double pit (double x1, double y1, double x2, double y2) {
  return (x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2);
}

int main() {


  int n, q, i, j;

  //freopen ("triangle.in", "r", stdin);
  //freopen ("triangle.out", "w", stdout);
  cin >> n >> q;

  for (i = 1; i <= n; i++) {
    cin >> x[i] >> y[i];
  }

  for (i = 1; i <= n; i++) {
    for (j = i + 1; j <= n; j++) {
      double e = pit (x[i], y[i], x[j], y[j]);
      //cout << e << '\n';
      dist[i].push_back (e);
      dist[j].push_back (e);
    }
  }
  for (i = 1; i <= n; i++) {
    sort (dist[i].begin (), dist[i].end ());
    /*for (auto x : dist[i])
      cout << x << ' ';
    cout << '\n';*/
  }

  while (q--) {
    int sol = 0;
    double xx, yy;
    cin >> xx >> yy;
    // case 1
    mp.clear ();
    for (i = 1; i <= n; i++) {
      double e = pit (x[i], y[i], xx, yy);
      //if (q == 1)
      //  cout << e << ' ';
      sol = sol + mp[e];
      mp[e]++;
    }

    // case 2
    for (i = 1; i <= n; i++) {
      double e = pit (x[i], y[i], xx, yy);
      sol = sol + caut (e, i);
    }
    cout << sol << '\n';
  }
  return 0;
}
