/**
Task 3.
Triangle
**/
#include <iostream>
#include <cmath>
#include <algorithm>

using namespace std;

typedef double ld;

struct point
{
    ld x;
    ld y;
};

inline ld dist(point a,point b)
{
    ld dx=a.x-b.x;
    ld dy=a.y-b.y;
    return sqrt(dx*dx+dy*dy);
}

const int N=1000+5;

int n,t;
point v[N];
ld d[N];
ld dp[N][N];
int len[N][N];

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    cin>>n>>t;
    for(int i=1;i<=n;i++)
    {
        cin>>v[i].x>>v[i].y;
    }
    for(int i=1;i<=n;i++)
    {
        int cur=0;
        for(int j=1;j<=n;j++)
        {
            if(i==j) continue;
            d[++cur]=dist(v[i],v[j]);
        }
        sort(d+1,d+n);
        dp[i][n]=-1;
        for(int j=n-1;j>=1;j--)
        {
            dp[i][j]=d[j];
            if(fabs(dp[i][j]-dp[i][j+1])<=0.0001)
            {
                len[i][j]=1+len[i][j+1];
            }
            else
            {
                len[i][j]=1;
            }
        }
    }
    ld di;
    int r,pas;
    for(int tc=1;tc<=t;tc++)
    {
        point p;
        cin>>p.x>>p.y;
        int add=0;
        for(int j=1;j<=n;j++)
        {
            d[j]=dist(p,v[j]);
            di=dist(p,v[j]);
            r=0;
            pas=(1<<10);
            while(pas)
            {
                if(r+pas<n && dp[j][r+pas]-di<-0.0001)
                {
                    r+=pas;
                }
                pas/=2;
            }
            r++;
            int lol=0;
            if(1<=r && r<n && fabs(dp[j][r]-di)<=0.0001)
            {
                lol=len[j][r];
            }
            add+=lol;
        }
        sort(d+1,d+n+1);
        d[n+1]=-1;
        int le=0;
        for(int j=n;j>=1;j--)
        {
            if(fabs(d[j]-d[j+1])<=0.0001)
            {
                le++;
            }
            else
            {
                le=1;
            }
            add+=le-1;
        }
        cout<<add<<"\n";
    }
    return 0;
}

