/**
Task2 : Majorant
**/
#include <iostream>
#include <map>
#include <cstdio>

using namespace std;

const int N=10000+5+5;
const int MOD=998244353;

inline int add(register int a,register int b)
{
    a+=b;
    if(a>=MOD)
    {
        a-=MOD;
    }
    if(a<0)
    {
        a+=MOD;
    }
    return a;
}

inline int mul(register int a,register int b)
{
    return a*(long long)b%MOD;
}

int aib[2*N];

int care[2*N],id=0;

inline void addd(register int p,register int x)
{
    for(register int i=p;i<2*N;i+=i&(-i))
    {
        if(aib[i]==0)
        {
            care[++id]=i;
        }
        aib[i]+=x;
    }
}

inline int prefix(register int p)
{
    register int ans=0;
    for(register int i=p;i>=1;i-=i&(-i))
    {
        ans+=aib[i];
    }
    return ans;
}


int n;

int v[N];
bool viz[N];



inline int ask(register int st,register int dr)
{
    register int sol=0;
    for(register int i=st;i<=dr;i++)
    {
        viz[i]=0;
    }
    n+=2;
    register int x,cur,ans;
    for(register int i=st;i<=dr;i++)
    {
        if(viz[i]==0)
        {
            for(int j=1;j<=id;j++)
            {
                aib[care[j]]=0;
            }
            id=0;
            x=v[i];
            cur=n;
            ans=0;
            for(register int p=st;p<=dr;p++)
            {
                addd(cur,1);
                if(v[p]==x)
                {
                    viz[p]=1;
                    cur++;
                }
                else
                {
                    cur--;
                }
                ans=add(ans,prefix(cur-1));
            }
            sol=add(sol,mul(x,ans));
        }
    }
    n-=2;
    return sol;
}

int lst=0;

inline void test()
{
    register int l,r,t;
    cin>>l>>r>>t;
    register int type=(t+lst)%2+1;
    register int a,b;
    if(type==1)
    {
        a=(l+lst)%n+1;
        b=(r+lst)%100000000+1;
        v[a]=b;
    }
    else
    {
        a=(l+lst)%n+1;
        b=(r+lst)%n+1;
        lst=ask(a,b);
        cout<<lst<<"\n";
    }
}

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    cin>>n;
    for(register int i=1;i<=n;i++)
    {
        cin>>v[i];
    }
    register int q;
    cin>>q;
    while(q--)
    {
        test();
    }
    return 0;
}
/**

**/
