/**
Task1 : Trap
**/
#include <iostream>
#include <cmath>
#include <map>
#include <iomanip>

using namespace std;

typedef long double ld;

const int N=1000+5;
const ld EPS=0.0001;

struct point
{
    ld x;
    ld y;
};

inline ld dist(point a,point b)
{
    ld dx=a.x-b.x;
    ld dy=a.y-b.y;
    return sqrt(dx*dx+dy*dy);
}

int n,q;
point v[N];

struct DD /// dist
{
    ld ans;
};

bool operator < (DD a,DD b)
{
   /// cout<<"LOL\t"<<fixed<<setprecision(6)<<a.ans-b.ans<<"\t"<<EPS<<"\n";
    return a.ans-b.ans<-EPS;
}

int main()
{
    /**
    Testing operator <
    map<DD,int>f;
    DD aux;
    aux.ans=3.2344; f[aux]++;
    aux.ans=3.23453; f[aux]++;
    for(auto &x:f)
    {
        cout<<x.first.ans<<" : "<<x.second<<"\n";
    }
    return 0;
    **/
    cin>>n>>q;
    for(int i=1;i<=n;i++)
    {
        cin>>v[i].x>>v[i].y;
    }
    while(q--)
    {
        point p;
        cin>>p.x>>p.y;
        map<DD,int>f;
        DD aux;
        for(int i=1;i<=n;i++)
        {
            aux.ans=dist(p,v[i]);
            f[aux]++;
        }
        int ans=0;
        for(auto &x:f)
        {
            int cnt=x.second;
            ans+=cnt*(cnt-1)/2;
        }
        cout<<ans<<"\n";
    }
    return 0;
}
/**
4 3
0.0 5.0
3.0 4.0
4.0 3.0
5.0 0.0
5.0 5.0
0.0 0.0
0.0 9.0

**/
