/**
Task 3.
Triangle
**/
#include <iostream>
#include <cmath>
#include <map>
#include <cstdio>

using namespace std;

typedef long double ld;

const ld EPS=0.0001;

struct point
{
    ld x;
    ld y;
};

inline ld dist(point a,point b)
{
    ld dx=a.x-b.x;
    ld dy=a.y-b.y;
    return sqrt(dx*dx+dy*dy);
}

const int N=1000+5;

int n,t;
point v[N];

inline bool eq(ld x,ld y)
{
    ld dif=fabs(x-y);
    if(dif<=EPS)
    {
        return 1;
    }
    else
    {
        return 0;
    }
}

inline bool is(point a,point b,point c)
{
    ld x=dist(a,b);
    ld y=dist(a,c);
    ld z=dist(b,c);
    if(eq(x,y) || eq(x,z) || eq(y,z))
    {
        return 1;
    }
    else
    {
        return 0;
    }
}

struct DD
{
    ld a;
};

bool operator < (DD x,DD y)
{
    return x.a-y.a<-EPS;
}

map<DD,int>fid[N];

int main()
{
   // freopen("input","r",stdin);
  //  freopen("output","w",stdout);
    /**
    map<DD,int>f;
    DD F,S;
    F.a=0.3256; f[F]++;
    S.a=0.3254; f[S]++;
    cout<<"Real = "<<eq(F.a,S.a)<<"\n";
    for(auto &x:f)
    {
        cout<<"\t\t"<<x.first.a<<" "<<x.second<<"\n";
    }
    return 0;
    **/
    cin>>n>>t;
    for(int i=1;i<=n;i++)
    {
        cin>>v[i].x>>v[i].y;
    }
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=n;j++)
        {
            if(i==j)
            {
                continue;
            }
            DD aux;
            aux.a=dist(v[i],v[j]);
            fid[i][aux]++;
        }
    }
    for(int tc=1;tc<=t;tc++)
    {
        point p;
        cin>>p.x>>p.y;
        int ans=0;
        map<DD,int>f;
        for(int i=1;i<=n;i++)
        {
            DD aux;
            aux.a=dist(p,v[i]);
            ans+=f[aux];
            f[aux]++;
        }
        int add=0;
        for(int i=1;i<=n;i++)
        {
            DD now;
            now.a=dist(p,v[i]);
            add+=fid[i][now];
        }
        ans+=add;
        cout<<ans<<"\n";
    }
    return 0;
}
