/**
Task 3.
Triangle
**/
#include <iostream>
#include <cmath>
#include <map>
#include <cstdio>

using namespace std;

typedef long double ld;

const ld EPS=0.0001;

struct point
{
    ld x;
    ld y;
};

inline ld dist(point a,point b)
{
    ld dx=a.x-b.x;
    ld dy=a.y-b.y;
    return sqrt(dx*dx+dy*dy);
}

const int N=1000+5;

int n,t;
point v[N];

struct DD
{
    ld a;
};

bool operator < (DD x,DD y)
{
    return x.a-y.a<-EPS;
}

map<DD,int>fid[N];

int main()
{
  //  freopen("input","r",stdin);
  //  freopen("output","w",stdout);
    cin>>n>>t;
    for(int i=1;i<=n;i++)
    {
        cin>>v[i].x>>v[i].y;
    }
    for(int i=1;i<=n;i++)
    {
        for(int j=i+1;j<=n;j++)
        {
            DD aux;
            aux.a=dist(v[i],v[j]);
            fid[i][aux]++;
        }
    }
    for(int tc=1;tc<=t;tc++)
    {
        point p;
        cin>>p.x>>p.y;
        int ans=0;
        map<DD,int>f;
        for(int i=1;i<=n;i++)
        {
            DD aux;
            aux.a=dist(p,v[i]);
            ans+=f[aux];
            f[aux]++;
        }
        int add=0;
        for(int i=1;i<=n;i++)
        {
            DD now;
            now.a=dist(p,v[i]);
            add+=fid[i][now];
        }
        ans+=add;
        cout<<ans<<"\n";
    }
    return 0;
}
