#include <iostream>
#include <unordered_map>
#include <vector>
#include <cassert>
#include <map>

using namespace std;

#define ll long long
#define MIN(a , b) (((a) < (b)) ? (a) : (b))
#define MAX(a , b) (((a) < (b)) ? (b) : (a))

int const nmax = 200000;
int const modulo = 998244353;
int const valmax = 100000000;

int v[5 + nmax];

int solve(int from , int to){
  int result = 0;
  for(int i = from ; i <= to ; i++) {
    map<int , int> frec;
    int cand = 0;
    int sum = 0;

    for(int j = i ; j <= to ; j++){
      frec[v[j]]++;
      if(v[j] == cand)
        sum++;
      else
        sum--;

      if(sum < 0)
        cand = v[j];

      if((j - i + 1) / 2 < frec[cand]) {
        result += cand % modulo;
        if(modulo <= result)
          result -= cand;
      }
    }
  }
  return result;

}

int main()
{
  int n;
  cin >> n;
  for(int i = 1 ; i <= n ; i++)
    cin >> v[i];
  int m , last = 0;
  cin >> m;
  for(int i = 1 ; i <= m ; i++){
    int p , q , t;
    cin >> p >> q >> t;
    t = (last + t) % 2 + 1;
    if(t == 1){
      p = (last + p) % n + 1;
      q = (last + q) % valmax + 1;
      v[p] = q;
    } else {
      p = (last + p) % n + 1;
      q = (last + q) % n + 1;
      last = solve(p , q);
      assert(p <= q);

      cout << last << '\n';

    }
  }
  return 0;
}
