#include <iostream>
#include <fstream>

using namespace std;

ifstream in ("trap.in");
ofstream out ("trap.out");

#define ll long long
#define MIN(a , b) (((a) < (b)) ? (a) : (b))
#define MAX(a , b) (((a) < (b)) ? (b) : (a))

int const nmax = 30;
int const iplus[4] = {0 , 0 , 1 , -1};
int const jplus[4] = {1 , -1 , 0 , 0};

int used[5 + 2 * nmax][5 + 2 * nmax];

ll result = 0;

void backt(int step , int lim , int x , int y , bool cangodown){

  if(step == lim){
    bool ok = 1;
    for(int h = 0 ; h < 4 ; h++){
      int newx = x + iplus[h];
      int newy = y + jplus[h];
      if(used[newx][newy] == 0) {
        ok = 0;
        break;
      }
    }

    result += ok;
  } else {
    used[x][y] = 1;

    for(int h = 0 ; h < 4 ; h++){
      int newx = x + iplus[h];
      int newy = y + jplus[h];
      if(used[newx][newy] == 0) {
        if(h == 3)
          backt(step + 1 , lim , newx , newy , 1);
        else{
          if(h != 2)
            backt(step + 1 , lim , newx , newy , cangodown);
          else if(cangodown == 1)
            backt(step + 1 , lim , newx , newy , cangodown);
        }
      }
    }

    used[x][y] = 0;
  }

}

void solve(int n){
  result = 0;
  used[nmax][nmax] = 1;
  backt(1 , n , nmax , nmax + 1, 0);
  out << result << " ";
  cout << n << " " << result << '\n';
}

ll sol[5 + nmax] = {0 , 0 ,0, 0 ,0 ,0 ,0 ,1 ,2 ,11, 25, 95 ,228 ,752 ,1860 ,5741 ,14477 ,42939 ,109758 ,317147 ,818229 ,2322512 ,6030293 ,16900541, 44079555, 122379267, 320227677 };


int main()
{
  int n;
  cin >> n;
  cout << sol[n];

  /*
  for(int i = 1 ; i < 27 ; i++)
    solve(i);
  */

  return 0;
}
