#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>

using namespace std;


int const nmax = 1000;
double const eps = 0.0001;

double dist(double x , double y , double x2 , double y2){
  return sqrt((x2 - x) * (x2 - x) + (y2 - y) * (y2 - y));
}

double v[5 + nmax][2];

double dist2[5 + nmax][5 + nmax];

int binarysearch(int from ,int to , double distmax , int node){
  for(int step = (1 << 20) ; 0 < step ; step /= 2){
    if(from + step <= to)
    if(dist2[node][from + step] <= distmax)
      from += step;
  }
  return from;
}

int main()
{
  ios::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);

  int n , q;
  cin >> n >> q;
  for(int i = 1 ; i <= n ; i++)
    cin >> v[i][0] >> v[i][1];
  for(int i = 1 ; i <= n ; i++) {
    for(int j = 1 ; j <= n ; j++) {
      dist2[i][j - 1] = (dist(v[i][0] , v[i][1] , v[j][0] , v[j][1]));
    }

    sort(dist2[i] , dist2[i] + n);
  }

  for(int i = 1 ; i <= q ; i++){
    double x , y;
    long long result = 0;
    long long result2 = 0;

    cin >> x >> y;


    for(int j = 1 ; j <= n ; j++) {
      dist2[n + 1][j] = (dist(x , y , v[j][0] , v[j][1]));
    }

    sort(dist2[n + 1] , dist2[n + 1] + n + 1);

    //*

    for(int j = 1 ; j <= n ; j++){
      ///the edge between us and j exists
      double distmax = dist(x , y , v[j][0] , v[j][1]);

      //binarysearch(0 , n - 1 , distmax + eps , j);
      result += binarysearch(0 , n - 1 , distmax + eps , j) -  binarysearch(0 , n - 1 , distmax - eps , j);
      result2 += binarysearch(0 , n , distmax + eps , n + 1) - binarysearch(0 , n , distmax - eps , n + 1) - 1;

   }

    cout << result + result2 / 2 << '\n' ;
    //*/
  }

  return 0;
}
