#include <bits/stdc++.h>

using namespace std;

const int NMAX=1e3+5;

const long double eps=0.0001;

struct point
{
    long double X, Y;
};

point A[NMAX];

long double Dist (point A, point B)
{
    return (sqrt)((A.X-B.X)*(A.X-B.X) + (A.Y-B.Y)*(A.Y-B.Y));
}

int N, i, Q;

long double X, Y;

long double abso (long double X)
{
    if(X<0)
        X*=-1;

    return X;
}

struct segment
{
    long double distanta;

    int start, finish;
};

bool cmp (segment A, segment B)
{
    if(A.distanta > B.distanta)
        return false;

    return true;
}

segment S[NMAX];

int vf=0;

int main()
{
    cin.tie(NULL);

    cin>>N>>Q;

    for(i=1; i<=N; ++i)
        cin>>A[i].X>>A[i].Y;

    for(i=1; i<=Q; ++i)
    {
        cin>>X>>Y;

        vf=0;

        for(int j=1; j<=N; ++j)
        {
            ++vf;

            S[vf].distanta=Dist({X, Y}, A[j]);
            S[vf].start=N+1;
            S[vf].finish=j;
        }

        sort(S+1, S+vf+1, cmp);

        int ans=0;

        int cnt=1;

        for(int j=1; j<N; ++j)
        {
            long double d1=Dist(A[S[j].finish], A[S[j+1].finish]);
            long double d2=Dist(A[S[j].finish], {X, Y});
            long double d3=Dist(A[S[j+1].finish], {X, Y});

            if(abso(d1-d2) < eps || abso(d1-d3) < eps || abso(d2-d3) < eps)
            {
                cnt=1;

                while((abso(d1-d2) < eps || abso(d1-d3) < eps || abso(d2-d3) < eps) && (j<N))
                {
                    ++cnt;
                    ++j;

                    if(j<N)
                    {
                        d1=Dist(A[S[j].finish], A[S[j+1].finish]);
                        d2=Dist(A[S[j].finish], {X, Y});
                        d3=Dist(A[S[j+1].finish], {X, Y});
                    }
                }

                --cnt;

                ans+=(cnt*(cnt+1))/2;
            }
        }

        cout<<ans<<'\n';
    }

    return 0;
}
