#include <bits/stdc++.h>

using namespace std;

const int MAXN = 1001;
const double EPS = 1e-4;

pair <double, double> a[MAXN];

inline double getr(double x1, double y1, double x2, double y2) {
    return hypot(x1 - x2, y1 - y2);
}

double d[MAXN][MAXN];
double v[MAXN];

signed main() {
    //freopen("input.txt", "r", stdin);

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, q;
    cin >> n >> q;
    for (int i = 0; i < n; ++i) cin >> a[i].first >> a[i].second;

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            d[i][j] = getr(a[i].first, a[i].second, a[j].first, a[j].second);
        }
        sort(d[i], d[i] + n);
    }

    for (int t = 0; t < q; ++t) {
        double x, y;
        cin >> x >> y;
        int ans = 0;
        for (int i = 0; i < n; ++i) {
            v[i] = getr(a[i].first, a[i].second, x, y);
            ans += lower_bound(d[i], d[i] + n, v[i] + EPS) - upper_bound(d[i], d[i] + n, v[i] - EPS);
        }
        sort(v, v + n);
        for (int i = 0; i < n; ++i) {
            ans += (lower_bound(v, v + n, v[i] + EPS) - v) - i - 1;
        }
        cout << ans << '\n';
    }

    return 0;
}
