#include <bits/stdc++.h>
#define FOR(i, n) for (int i = 0; i < n; ++i)
#define debug(x) std::cout << #x << ": " << x << '\n';

typedef long long ll;
const int N = 100;
struct point {
	double x, y;
};

point a[N];

double dist(point a, point b) {
	return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y);
}
bool cmp(double a, double b) {
	return fabs(a - b) < 0.0001;
}

int main() {
	// std::ios::sync_with_stdio(false);
	// std::cin.tie(0); std::cout.tie(0);
	int n, q;
	std::cin >> n >> q;
	// debug(n << ' ' << q);	
	std::map<double, int> cnt2;
	FOR(i, n) {
		std::cin >> a[i].x >> a[i].y;
		// debug(a[i].x << ' ' << a[i].y);
	}
	FOR(i, q) {
		point O;
		std::cin >> O.x >> O.y;
		ll answ2 = 0;
		FOR(i, n) {
			FOR(j, n) {
				if (i <= j) {
					continue;
				}
				double dist1 = dist(O, a[i]);
				double dist2 = dist(O, a[j]);
				double dist3 = dist(a[i], a[j]);
				if (cmp(dist1, dist2) || cmp(dist2, dist3) || cmp(dist1, dist3)) {
					answ2++;
				}
			}
		}
		std::cout << answ2 << '\n';
	}
}