#include <bits/stdc++.h>
#define FOR(i, n) for (int i = 0; i < n; ++i)
#define debug(x) std::cout << #x << ": " << x << '\n';

typedef long long ll;
const int N = 1001;
struct point {
	double x, y;
};

point a[N];

double kek[N][N];

double dist(point &a, point &b) {
	return sqrt((a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y));
}

int main() {
	std::ios::sync_with_stdio(false);
	std::cin.tie(0); std::cout.tie(0);
	int n, q;
	std::cin >> n >> q;
	// debug(n << ' ' << q);
	FOR(i, n) {
		std::cin >> a[i].x >> a[i].y;
		// debug(a[i].x << ' ' << a[i].y);
	}
	int answ1 = 0;
	FOR(i, n) {
		int sz = 0;
		FOR(j, n) {
			if (j == i) {
				continue;
			}
			kek[i][sz++] = dist(a[i], a[j]);
		}
		std::sort(kek[i], kek[i] + sz);
	}
	FOR(i, q) {
		point O;
		std::cin >> O.x >> O.y;
		std::vector<double> v(n);
		int answ2 = 0;
		FOR(i, n) {
			double d = dist(O, a[i]);
			v[i] = d;

			answ2 += (std::upper_bound(kek[i], kek[i] + n - 1, d + 0.0001) - 
						std::lower_bound(kek[i], kek[i] + n - 1, d - 0.00009));
			// debug(dist(O, a[i]));
		}
		int l = 0, r = 1;
		std::sort(v.begin(), v.end());
		// debug(answ1);
		while (l < v.size()) {
			while (r < v.size() && std::fabs(v[r] - v[l]) < 0.0001) {
				++r;
			}
			answ2 += (r - l) * (r - l - 1) / 2;
			l = r;
			r++;
		}
		std::cout << answ2 << '\n';
	}
}