#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>

using namespace std;

#define ld long double
#define ll long long
#define left left228
#define right right228

template<typename T> void uin(T &a, T b) {
	if (b < a) {
		a = b;
	}
}

template<typename T> void uax(T &a, T b) {
	if (b > a) {
		a = b;
	}
}

const int maxn = 1001;

const ld eps = 0.0001;

struct point
{
	ld x, y;
	point() {}
	point(ld _x, ld _y) {
		x = _x;
		y = _y;
	}
};

ld get_dist(point a, point b) {
	return sqrt((a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y));
}

int n, q;

point p[maxn];

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cin >> n >> q;
	for (int i = 1; i <= n; ++i) {
		cin >> p[i].x >> p[i].y;
	}
	ld D1, D2, D3;
	for (int iter = 0; iter < q; ++iter) {
		point a;
		cin >> a.x >> a.y;
		int res = 0;
		for (int i = 1; i <= n; ++i) {
			for (int j = i + 1; j <= n; ++j) {
				D1 = get_dist(a, p[i]);
				D2 = get_dist(a, p[j]);
				D3 = get_dist(p[i], p[j]);
				if (abs(D1 - D2) < eps || abs(D2 - D3) < eps || abs(D1 - D3) < eps) {
					++res;
				}
			}
		}
		cout << res << '\n';
	}
	return 0;
}