#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>

using namespace std;

#define ld long double
#define ll long long
#define left left228
#define right right228

template<typename T> void uin(T &a, T b) {
	if (b < a) {
		a = b;
	}
}

template<typename T> void uax(T &a, T b) {
	if (b > a) {
		a = b;
	}
}

const int maxn = 1001;

const ld eps = 0.0001;

struct point
{
	ld x, y;
	point() {}
	point(ld _x, ld _y) {
		x = _x;
		y = _y;
	}
};

ld get_dist(point a, point b) {
	return sqrt((a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y));
}

int n, q;

point p[maxn];

ld dst[maxn];

vector<ld> d[maxn];

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cin >> n >> q;
	for (int i = 1; i <= n; ++i) {
		cin >> p[i].x >> p[i].y;
	}
	for (int i = 1; i <= n; ++i) {
		d[i].reserve(n);
		for (int j = 1; j <= n; ++j) {
			d[i].push_back(get_dist(p[i], p[j]));
		}
		sort(d[i].begin(), d[i].end());
	}
	int res = 0;
	int l, r;
	for (int iter = 0; iter < q; ++iter) {
		point a;
		cin >> a.x >> a.y;
		res = 0;
		int cc = 0;
		for (int i = 1; i <= n; ++i) {
			dst[i] = get_dist(a, p[i]);
			if (dst[i] < eps) {
				++cc;
				continue;
			}
			l = lower_bound(d[i].begin(), d[i].end(), dst[i] - eps) - d[i].begin();
			r = upper_bound(d[i].begin(), d[i].end(), dst[i] + eps) - d[i].begin() - 1;
			res += max(0, r - l + 1);
		}
		res += cc * (cc - 1) / 2;
		sort(dst + 1, dst + n + 1);
		r = 0;
		for (int i = 1; i <= n; ++i) {
			while (r + 1 <= n && dst[r + 1] - dst[i] < eps) ++r;
			res += r - i;
		}
		cout << res << '\n';
	}
	return 0;
}