#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;

#define all(x) (x).begin(), (x).end()
#define pb push_back
#define size(x) (int)x.size()
#define W(x) cout << (#x) << ": " << x << '\n';

const ld EPS = 0.0001;

inline ld norm(ld a, ll eps = 10000) {
    return ld(int(a*eps))/eps;
}

double dist(pair<ld, ld> a, pair<ld, ld> b){
    return norm(hypot(a.first - b.first, a.second - b.second));
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    #ifdef _BULAT
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
	#endif
	int n, q;
	cin >> n >> q;
	vector<pair<ld, ld>> a(n);
    for(int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
    }
    vector<vector<ld>> d(n, vector<ld>(n));
    map<pair<int, ld>, int> cnt;
    for(int i = 0; i < n; i++){
        for(int j = i + 1; j < n; j++){
            d[i][j] = dist(a[i], a[j]);
            d[j][i] = d[i][j];
            cnt[{i, d[i][j]}]++;
            cnt[{j, d[j][i]}]++;
        }
    }
    while(q--) {
        pair<ld, ld> ct;
        cin >> ct.first >> ct.second;
        vector<ld> di(n);
        unordered_map<ld, int> kek;
        for(int i = 0; i < n; i++) {
            di[i] = dist(ct, a[i]);
            kek[di[i]]++;
        }
        ll ans = 0;
        for(auto e : kek){
            ans += (e.second)*(e.second - 1);
        }
        for(int i = 0; i < n; i++){
            ans += cnt[{i, di[i]}];
        }
        cout << ans/2 << '\n';
    }
}
