#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;

#define all(x) (x).begin(), (x).end()
#define pb push_back
#define size(x) (int)x.size()
#define W(x) cout << (#x) << ": " << x << '\n';

inline ll dist(pair<ld, ld> a, pair<ld, ld> b){
    ld kek = (a.first - b.first) * (a.first- b.first) +
    (a.second - b.second) * (a.second - b.second) ;
    return kek*10000;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    #ifdef _BULAT
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
	#endif
	int n, q;
	cin >> n >> q;
	vector<pair<ld, ld>> a(n);
    for(int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
    }
    vector<vector<ll>> d(n, vector<ll>(n));
    for(int i = 0; i < n; i++){
        for(int j = i + 1; j < n; j++){
            d[i][j] = dist(a[i], a[j]);
            d[j][i] = d[i][j];
        }
        d[i].pb(1e18);
        sort(all(d[i]));
    }
    while(q--) {
        pair<ld, ld> ct;
        cin >> ct.first >> ct.second;
        vector<ll> di(n);
        unordered_map<ll, int> cnt;
        for(int i = 0; i < n; i++) {
            di[i] = dist(ct, a[i]);
            cnt[di[i]]++;
        }
        ll ans = 0;
        for(auto e : cnt) {
            ans += (e.second)*(e.second - 1);
        }
        ans/=2;
        for(int i = 0; i < n; i++){
            ans += (upper_bound(all(d[i]), di[i]) - d[i].begin()) - (lower_bound(all(d[i]), di[i]) - d[i].begin());
        }
        cout << ans << '\n';
    }
}
