#include <bits/stdc++.h>

using namespace std;
const int MAX = 200000;
const long long MoD = 100000000, MOD = 998244353;
int n, a[MAX];

void decode (long long l, long long r, long long t, long long last, int& type, int& p, int& q);
int Query (long long p, long long q);

int main()
{
    ios::sync_with_stdio (false);
    cin.tie (0);

    cin >> n;

    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    int nTest;
    cin >> nTest;

    int last = 0;
    for (int tests = 0; tests < nTest; ++tests) {
        long long l, r, t;
        cin >> l >> r >> t;
        int type, p, q;
        decode (l, r, t, last, type, p, q);

        //cout << type << ' ' << p << ' ' << q << endl;

        if (type == 1) {
            a[p - 1] = q;
        }

        if (type == 2) {
            last = Query (p - 1, q - 1); // fr 0
            cout << last << endl;
        }
    }


    return 0;
}

void decode (long long l, long long r, long long t, long long last, int& type, int& p, int& q) {
    type = ((t + last) % 2) + 1;

    if (type == 1) {
        p = ((l + last) % n) + 1;
        q = ((r + last) % MoD) + 1;
    }

    if (type == 2) {
        p = ((l + last) % n) + 1;
        q = ((r + last) % n) + 1;
    }
}

int Query (long long p, long long q) {
    //cout << p << ' ' << q << endl;
    map <int, int> was;
    long long ans = 0;
    for (int IDmojar = p; IDmojar <= q; ++IDmojar) {
        int x = a[IDmojar];
        if (was[x]) { continue; }
        was[x] = true;

        int cnt = 0; //n massiv that have mojar x
        for (int l = p; l <= q; ++l) {
            for (int r = l; r <= q; ++r) {
                int cntW = 0;

                for (int ID = l; ID <= r; ++ID) {
                    if (a[ID] == x) { ++cntW; }
                }

                if (cntW > (r - l + 1) / 2) {
                    ++cnt;
                }

               // cout << "*" << ' ';
            }
           // cout << endl;
        }
        ans += (long long)cnt * x;
    }

    return (ans % MOD);
}


