#include <bits/stdc++.h>

using namespace std;

const int MAX = 1027;
const long double ESP = 0.0001;

long double _distance (pair<long double, long double>& one, pair<long double, long double>& two);
bool equaly (long double one, long double two);

int main()
{
    int nPoint, nTest;
    cin >> nPoint >> nTest;
    vector<pair<long double, long double>> Point(nPoint);

    for (int i = 0; i < nPoint; ++i) {
      cin >> Point[i].first >> Point[i].second;
    }

    for (int i = 0; i < nTest; ++i) {
      pair <long double, long double> first;
      cin >> first.first >> first.second;
      int ans = 0;

      for (auto& second : Point) {
        long double distant = _distance(second, first);

        for (auto& third : Point) {
          if (second == third) {
            continue;
          }

          long double distant1 = _distance(second, third);
          long double distant2 = _distance(third, first);

          if (equaly (distant1, distant2) || equaly (distant2, distant) || equaly (distant, distant2)) {
            ++ans;
          }
        }
      }
      ans /= 2;
      cout << ans << endl;
    }


    return 0;
}

long double _distance (pair<long double, long double>& one, pair<long double, long double>& two) {
    long double x = pow((one.first - two.first), 2);
    long double y = pow((one.second - two.second), 2);

    return x + y;
}

bool equaly (long double one, long double two) {
  return abs(one - two) < ESP;
}
