#include <bits/stdc++.h>
using namespace std;

typedef long double float80;

void solve();

int main() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    auto start = chrono::high_resolution_clock::now();
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    solve();
#ifdef DEBUG
    auto finish = chrono::high_resolution_clock::now();
    chrono::duration<double> d = finish - start;
    cout << setprecision(3) << fixed << "Time: " << d.count() << "s\n";
#endif // DEBUG
    return 0;
}

const int MAX_N = 1113, MOD = 998244353;

map<int, int> renum, rerenum;
int a[MAX_N], cnt[MAX_N], ans[MAX_N];

void solve() {
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i)
        cin >> a[i], renum[a[i]] = 0;
    int uncnt = 0;
    for (auto& p : renum)
        rerenum[uncnt] = p.first, p.second = uncnt++;
    for (int i = 0; i < n; ++i)
        a[i] = renum[a[i]];

    int last_output = 0, q;
    cin >> q;
    for (int iterations = 0; iterations < q; ++iterations) {
        int l, r, type;
        cin >> l >> r >> type;
        type = (type + last_output) % 2 + 1;
        if (type == 1) {
            l = (l + last_output) % n;
            r = (r + last_output) % 100000000 + 1;
            if (renum.find(r) == renum.end())
                rerenum[uncnt] = r, renum[r] = uncnt++;
            a[l] = renum[r];
        } else {
            for (int i = 0; i < MAX_N; ++i)
                ans[i] = 0;
            l = (l + last_output) % n;
            r = (r + last_output) % n + 1;
            for (int len = 1, p = r - l; len <= p; ++len) {
                for (int i = 0; i < MAX_N; ++i)
                    cnt[i] = 0;
                //cout << "LEN=" << len << "\n";
                for (int i = l, p2 = l + len; i < p2; ++i)
                    ++cnt[a[i]];
                int maj = -1;
                for (int i = 0; i < MAX_N; ++i)
                    if (cnt[i] > len / 2)
                        maj = i;
                //cout << "PREMAJ" << maj << "\n";
                for (int i = l, p2 = r - len; i <= p2; ++i) {
                    //cout << "CHECKING WITH LEN=" << len << " I=" << i << " J=" << i + len << " MAJ=" << maj << "\n";
                    if (maj != -1)
                        ++ans[maj];
                    --cnt[a[i]];
                    ++cnt[a[i + len]];
                    if (cnt[maj] <= len / 2)
                        maj = -1;
                    if (cnt[a[i + len]] > len / 2)
                        maj = a[i + len];
                }
            }
            int64_t answ = 0;
            for (int i = 0; i < MAX_N; ++i) {
                if (ans[i] != 0)
                    answ += 1ll * rerenum[i] * ans[i] % MOD;
            }
            answ %= MOD;
            cout << answ << "\n";
            last_output = answ;
        }
    }
}
