#include <bits/stdc++.h>
#define x first
#define y second
using namespace std;
typedef long double ld;
typedef long long ll;

pair<ld, ld> cur;

ld sqr(ld x) {
    return x * x;
}
const ld eps = 0.0001;
ld dist(pair<ld, ld> a, pair<ld, ld> b) {
    return sqrt(sqr(a.x - b.x) + sqr(a.y - b.y));
}

ld f(pair<ld, ld> a) {
    return (a.x * 1e9 + a.y);
}

int get(vector<ld> &v, ld d) {
    int l = -1, r = v.size();
    while(r - l > 1) {
        int m = (l + r) / 2;
        if (v[m] > d)
            r = m;
        else
            l = m;
    }
    return r;
}

int main() {
    ios :: sync_with_stdio(0);
    cin.tie(0);
    int n, k;
    ld t1, t2;
    cin >> n >> k;
    vector<pair<ld, ld>> s;
    unordered_map<ld, vector<ld>> m;
    for (int i = 0; i < n; i++) {
        cin >> t1 >> t2;
        s.push_back({t1, t2});
    }
    for (auto el : s) {
        for (auto el2 : s) {
            cur = el;
            if (el == el2)
                continue;
            m[f(el)].push_back(dist(el, el2));
        }
        sort(m[f(el)].begin(), m[f(el)].end());
    }
    for (int i = 0; i < k; i++) {
        cin >> t1 >> t2;
        pair<ld, ld> p = {t1, t2};
        vector<ld> v;
        int ans = 0;
        for (auto el : s) {
                v.push_back(dist(p, el));
        }
        sort(v.begin(), v.end());
        for (auto el : s) {
            ld d = dist(p, el);
            /*
            cout << '\t' << d << endl;
            for (int i = 0; i < m[el].size(); i++)
                cout << m[el][i] << ' ';
            cout << endl;
            */
            int it = get(m[f(el)], d - eps);
            if (it == m[f(el)].size())
                continue;
            auto it2 = get(m[f(el)], d + eps);
            if (it2 == 0)
                continue;
            it2--;
            ans += it2 - it + 1;
        }
        int ans2 = 0;
        for (auto el : s) {
            ld d = dist(p, el);
            auto it = get(v, d - eps);
            if (it == v.size())
                continue;
            auto it2 = get(v, d + eps);
            if (it2 == 0)
                continue;
            it2--;
            ans2 += it2 - it;
        }
        cout << ans + ans2 / 2 << endl;
    }
    return 0;
}
