#include <bits/stdc++.h>

using namespace std;

const double EPS =   0.0001;
const double SQEPS = 0.0002;

const int N = 1001;

double x[N], y[N];

double dx, dy;
inline double dist2(int i, int j)
{
    dx = x[i] - x[j];
    dy = y[i] - y[j];
    return dx * dx + dy * dy;
}

double ab, bc, ac;
bool good(int a, int b, int c)
{
    ab = dist2(a, b);
    bc = dist2(b, c);
    ac = dist2(a, c);
    return fabs(ab - bc) < SQEPS || fabs(bc - ac) < SQEPS || fabs(ac - ab) < SQEPS;
}

int n, q, answer;

int main()
{
    //freopen("input.txt", "r", stdin);
    ios::sync_with_stdio(0);
    cin.tie(nullptr);

    cin >> n >> q;

    for (int i = 0; i < n; ++i)
    {
        cin >> x[i] >> y[i];
    }

    while (q--)
    {
        cin >> x[n] >> y[n];
        answer = 0;
        for (int i = 0; i < n; ++i)
        {
            for (int j = i + 1; j < n; ++j)
            {
                if (good(i, j, n))
                {
                    ++answer;
                }
            }
        }
        cout << answer << '\n';
    }

    return 0;
}

