#include <bits/stdc++.h>
using namespace std;

#define pb push_back
#define F first
#define S second
#define all(v) (v.begin(), v.end())
#define sz(x) ll(x.size())
#define prll(x) cout << x << endl;
#define prll_v(v) for (auto xx : v) cout << xx << ' '; cout << endl;
typedef long long ll;
typedef pair < ll, ll > pii;
typedef pair < ll, ll > pll;
typedef double db;

const ll mod = 998244353;
const ll M = 1e8;
const char sp = ' ';

struct Int {
    ll x;
    Int (ll x = 0) : x(x) {};
};

#ifdef MY
    const ll N = 1e2;
    const ll inf = 1e9;
#else
    const ll N = 2e5 + 5;
    const ll inf = 1e9;
#endif // MY

ll lst[N];

bool check(set < pll > & res) {
    auto a = *(res.rbegin());
    res.erase(a);
    auto b = *(res.rbegin());
    res.insert(a);
    return a.F > b.F;
}

ll query(ll st, ll fn) {
    if (st > fn)
        swap(st, fn);
    map < ll, ll > forans;
    for (ll i = st; i <= fn; i++) {
        set < pll > res;
        unordered_map < ll, ll > cnt;
        for (ll j = i; j <= fn; j++) {
            res.erase({cnt[lst[j]], lst[j]});
            cnt[lst[j]]++;
            res.insert({cnt[lst[j]], lst[j]});
            ll k = sz(res);
//            if (res.size() >= 2) {
//                pll P = *((res.rbegin()--));
//                cout << " !!! "  << res.rbegin()->S << sp <<  (res.rbegin()--)->S << endl;
//            }
            if (res.rbegin()->F > (j - i + 1) / 2) {
                forans[res.rbegin()->S]++;
                //cout << res.rbegin()->F << sp << res.rbegin()->S << endl;
            }
        }
    }
    ll ans = 0;
    for (auto k : forans)
        ans = (ans + (k.F * k.S) % mod) % mod;
    return ans;
//    set < pll > res;
//    unordered_map < ll, ll > cnt;
//    res.insert(lst[l]);
//    ll l = st, r = st;
//    ll ans = 0;
//    for (r < fn) {
//        while (res.size() < 2 || *(res.rbegin()).F > *(res.rbegin() + 1) && r < fn) {
//            ans = (ans + *(res.rbegin()).S * (r - l + 1)) % mod;
//            r++;
//            res.erase({cnt[lst[r]], lst[r]});
//            cnt[lst[r]]++;
//            res.insert({cnt[lst[r]], lst[r]});
//        }
//        l++
//    }
}

int main() {
#ifdef MY
    freopen("f.in", "r", stdin);
#endif // MY
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll n, m;
    cin >> n;
    for (ll i = 0; i < n; i++)
        cin >> lst[i];
    ll cur = 0;
    cin >> m;
    for (ll i = 0; i < m; i++) {
        ll l, r, t;
        cin >> l >> r >> t;
        t = (t + cur) % 2 + 1;
        if (t == 1) {
            ll p = (l + cur) % n, q = (r + cur) % M + 1;
            lst[p] = q;
            continue;
        }
        l = (l + cur) % n, r = (r + cur) % n;
        cout << (cur = query(l, r)) << '\n';
    }
    return 0;
}
