#include <bits/stdc++.h>
using namespace std;

#define pb push_back
#define F first
#define S second
#define all(v) (v.begin(), v.end())
#define sz(x) ll(x.size())
#define prll(x) cout << x << endl;
#define prll_v(v) for (auto xx : v) cout << xx << ' '; cout << endl;
typedef long long ll;
typedef pair < ll, ll > pii;
typedef pair < ll, ll > pll;
typedef double db;

const ll mod = 998244353;
const ll M = 1e8;
const char sp = ' ';

struct Int {
    ll x;
    Int (ll x = 0) : x(x) {};
};

#ifdef MY
    const ll N = 1e2;
    const ll inf = 1e9;
#else
    const ll N = 2e5 + 5;
    const ll inf = 1e9;
#endif // MY

ll lst[N];
ll n, m;
unordered_map < int, vector < int > > bd;
int nxt[N];
int prv[N];
bool used[N];

void rebuild(int in, int x) {
    if (lst[in] == x)
        return;
    if (prv[in] != -1)
        nxt[prv[in]] = in;
    if (nxt[in] != n)
        prv[nxt[in]] = in;
    int l =  -1, r = n;
    for (int i = 0; i < n; i++) {
        if (lst[i] == x) {
            if (i < in)
                l = i;
            else {
                r = i;
                break;
            }
        }
    }
    prv[in] = l;
    nxt[in] = r;
    lst[i] = x;
}

ll query(int st, int fn) {
    fill(used + st, used + fn, 0);
    for (int i = st; i <= fn; i++) {
        if (used[i])
            continue;
        int cnt = 0;
        for (int j = i; j <= fn; j = nxt[j]) {
            cnt++;
            int len = cnt * 2 - 1;
        }
    }
}

int main() {
#ifdef MY
    freopen("f.in", "r", stdin);
#endif // MY
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n;
    fill(nxt, nxt + n, n);
    fill(pr, pr + n, -1);
    for (ll i = 0; i < n; i++) {
         cin >> lst[i];
         bd[lst[i]].pb(i);
    }
    for (auto lst : bd) {
        if (sz(lst) == 1)
            continue;
        for (int i = 0; i < sz(lst); i++) {
            if (i == 0) {
                nxt[lst[i]] = lst[i + 1];
            } else if (i + 1 == sz(lst)) {
                prv[lst[i]] = lst[i - 1];
            } else {
                nxt[lst[i]] = lst[i + 1];
                prv[lst[i]] = lst[i - 1];
            }
        }
    }
    ll cur = 0;
    cin >> m;
    for (ll i = 0; i < m; i++) {
        ll l, r, t;
        cin >> l >> r >> t;
        t = (t + cur) % 2 + 1;
        if (t == 1) {
            ll p = (l + cur) % n, q = (r + cur) % M + 1;
            rebuild(p, q);
            continue;
        }
        l = (l + cur) % n, r = (r + cur) % n;
        cout << (cur = query(l, r)) << '\n';
    }
    return 0;
}
