#include <bits/stdc++.h>

using namespace std;

void speed_up(){
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

void solve();
void solve1();
void solve2();
void solve3();

int main()
{
    speed_up();
    solve();
    return 0;
}

typedef long long ll;
#define F first
#define S second
#define pb push_back
#define all(x) (x).begin(),(x).end()
#define watch(x) cout<<#x<<" : "<<x<<"\n";

long double x[1001];
long double y[1001];
long double rs[1001][1001];

long double eps = 0.0001;

void solve(){
    int n;
    int q;
    cin>>n>>q;
    for(int i = 0 ; i < n; i ++){
        cin>>x[i]>>y[i];
    }
    for(int i = 0 ; i < n; i ++){
        for(int j = 0 ; j < n; j ++){
            rs[i][j] = sqrt((x[i] - x[j]) * (x[i] - x[j]) + (y[i] - y[j]) * (y[i] - y[j]));
        }
    }
    for(int i = 0 ; i < q; i++){
        long double xx,yy;
        cin>>xx>>yy;
        int ans = 0;
        for(int j = 0 ; j < n ; j ++){
            long double ij = sqrt((xx - x[j]) * (xx - x[j]) + (yy - y[j]) * (yy - y[j]));
            for(int k = 0; k < j; k++){
                long double ik = sqrt((xx - x[k]) * (xx - x[k]) + (yy - y[k]) * (yy - y[k]));
                long double jk = rs[j][k];
                if(fabs(ij - jk) < eps){
                    ans++;
                }else
                if(fabs(ik - jk) < eps){
                    ans++;
                }else
                if(fabs(ij - ik) < eps){
                    ans++;
                }
            }
        }
        cout<<ans<<"\n";
    }
}
