#include <iostream>
#include <vector>
#include <cmath>

#pragma GCC optimize("fast-math")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,tune=native")

#define ll long long
#define ld double
#define pb push_back
#define mp make_pair
#define ft first
#define sd second
#define eps 0.0333333333

using namespace std;

int main() {

    ios::sync_with_stdio(0);
    cin.tie();
    cout.tie();

    ld n , q;

    pair<ld , ld> a[1000];

    cin >> n >> q;

    for (ll i = 0; i < n; i++) {

        cin >> a[i].ft >> a[i].sd;
    }

    for (ll i = 0; i < q; i++) {
        ld x , y;

        cin >> x >> y;
        ll ans = 0;

        for (ll j = 0; j < n; j++) {
            ld r1 = abs(x - a[j].ft) * abs(x - a[j].ft) + abs(y - a[j].sd) * abs(y - a[j].sd);

            for (ll k = j + 1; k < n; k++) {
                ld r2 = abs(x - a[k].ft) * abs(x - a[k].ft) + abs(y - a[k].sd) * abs(y - a[k].sd);
                ld r3 = abs(a[j].ft - a[k].ft) * abs(a[j].ft - a[k].ft) + abs(a[j].sd - a[k].sd) * abs(a[j].sd - a[k].sd);

                if (abs(r1 - r2) < eps || abs(r2 - r3) < eps || abs(r1 - r3) < eps) {
                    ans++;
                }
            }
        }

        cout << ans << '\n';
    }
    return 0;
}
