#include <iostream>
#include <vector>
#include <cmath>
#include <map>

#pragma GCC optimize("fast-math")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,tune=native")

#define ll long long
#define ld double
#define pb push_back
#define mp make_pair
#define ft first
#define sd second
#define eps 0.0333333333

using namespace std;

int main() {

    ios::sync_with_stdio(0);
    cin.tie();
    cout.tie();

    ld n , q;

    pair<ld , ld> a[1000];
    map <ld , ld> allr;

    cin >> n >> q;

    for (ll i = 0; i < n; i++) {

        cin >> a[i].ft >> a[i].sd;
    }

    for (ll i = 0; i < n; i++) {

        for (ll j = i + 1; j < n; j++) {

            ld r = abs(a[j].ft - a[i].ft) * abs(a[j].ft - a[i].ft) + abs(a[j].sd - a[i].sd) * abs(a[j].sd - a[i].sd);
            allr[r]++;
        }

    }

    for (ll i = 0; i < q; i++) {
        ld x , y;

        cin >> x >> y;
        ll ans = 0;
        map <ld , ld> ras;

        for (ll j = 0; j < n; j++) {
            ld r1 = abs(x - a[j].ft) * abs(x - a[j].ft) + abs(y - a[j].sd) * abs(y - a[j].sd);

            if (allr.find(r1) != allr.end()) {
                ans += allr[r1];
            }

            if (ras.find(r1) != ras.end()) {
                ans += ras[r1];
            }
            ras[r1]++;

        }

        cout << ans << '\n';
    }
    return 0;
}
