#include <iostream>
#include <vector>
#include <map>

#pragma GCC optimize("fast-math")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,tune=native")

#define ll long long
#define ld double
#define pb push_back
#define mp make_pair
#define ft first
#define sd second
#define eps 0.0000001
#define mod 998244353

using namespace std;

pair<ll , ll> maj[2000][2000];

int main() {

    ios::sync_with_stdio(0);
    cin.tie();
    cout.tie();

    vector <ll> a(2000);

    ll n;
    cin >> n;

    for (ll i = 1; i <= n; i++) {

        cin >> a[i];
    }

    for (ll v1 = 1; v1 <= n; v1++) {
        map <ll , ll, greater<ll>> mv;
        for (ll v2 = v1; v2 <= n; v2++) {
            mv[a[v2]]++;
            ll mj = mv.begin() -> first;
            maj[v1][v2] = *mv.begin();
        }
    }

    ll q;
    ll lst = 0;

    cin >> q;

    for (ll i = 0; i < q; i++) {
        ll l , r , t;

        cin >> l >> r >> t;

        t = ((t + lst) % 2) + 1;

        l = ((l + lst) % n) + 1;

        if (t == 2) {
            r = ((r + lst) % n) + 1;
            ll ans = 0;
            map <ll,  ll> m;

            for (ll v1 = l; v1 <= r; v1++) {
                for (ll v2 = v1; v2 <= r; v2++) {
                    ll mj = maj[v1][v2].ft;
                    ll mx = maj[v1][v2].sd;


                    if (v2 - v1 + 1 - mx >= mx) {
                        continue;
                    }

                    m[mj]++;
                }
            }

            for (auto x: m) {
                ans += ((x.ft * x.sd) % mod);
            }
            ans %= mod;
            cout << ans << '\n';
            lst = ans;
        }
        else {
            r = ((r + lst) % 100000000) + 1;
            a[l] = r;

            for (ll v1 = 1; v1 <= n; v1++) {
                map <ll , ll , greater<ll>> mvv;
                for (ll v2 = v1; v2 <= n; v2++) {
                    mvv[a[v2]]++;
                    ll mj = mvv.begin() -> first;
                    maj[v1][v2] = *mvv.begin();
                }
            }
        }
    }
    return 0;
}
